;(function(){

    window._w.customercompletevaluation = {

        itemId : null,
        itemData : null,
        formMeta : null,
        ti : null,
        limited : false,
        newItem : false,
        validations : 0,
        highestOfferId : false,
        priceGuideId : false,
        publicCentreList : {},
        currentStep : 1,

        onCustomerCompleteValuationViewTemplateReady : function( template, event, eventData )
        {
            //console.log('onCustomerCompleteValuationViewTemplateReady');

            _w.customercompletevaluation.itemData = null;
            _w.customercompletevaluation.ti = _t[template];
            _w.customercompletevaluation.limited = false;
            // Retrieve initial view data.
            _w.customercompletevaluation.itemId = 0;

            var customerHash = App.Util.getUrlParam('customer');
            //console.log('hash', customerHash);

            App.Ajax.JSON({
                    "url"  : 'workspace/complete-valuation-get-customer',
                    "data" : {'customerHash' : customerHash}
                },
                $.proxy(function(response) {

                    console.log('response',response);

                    if(response.Error)
                    {
                        alert(response.Error);
                        return;
                    }

                    _w.customercompletevaluation.itemId = response.Success.valuationId;
                    App.API.getTask(
                        'updateValuation:' + _w.customercompletevaluation.itemId, 'Valuation', 'Valuation.UpdateCompleteCustomerPublic', null,
                        {'id':_w.customercompletevaluation.itemId}, $.proxy( _w.customercompletevaluation._onCustomerCompleteValuationViewDataReceived, this ), _w.taskContractError
                    );


                    App.Ajax.JSON({
                            "url"  : 'workspace/populate-complete-valuation-appointment-table',
                            "data" : {'currentPosition' : '0','valuationId' : _w.customercompletevaluation.itemId}
                        },
                        $.proxy(function(response) {
                            $('#completeValuationGridColumnHeaders').html(response.outputTableHeader);
                            $('#completeValuationGridRowRepeater').html(response.outputTableBody);


                        },this),
                        $.proxy(function(response) {
                            console.log('App.Notification.remove Error', response);
                        },this)
                    );

                },this),
                $.proxy(function(response) {
                    console.log('App.Notification.remove Error', response);
                },this)
            );


            _w.customercompletevaluation.setValuationViewFormMeta();
            _w.customercompletevaluation.ti.hydrate(_w.customercompletevaluation.formMeta);


            _w.customercompletevaluation.newItem = true;
            _w.customercompletevaluation.itemData = {stock:{}};
            App.API.getTask(
                'createCustomerValuation', 'Valuation', 'Valuation.CreateCompleteCustomerPublic',
                null, {}, function(){}, _w.taskContractError
            );
        },

        onCustomerCompleteValuationViewPublished : function( template, event, eventData )
        {

            App.API.getTask(
                'createCustomerValuation', 'Valuation', 'Valuation.CreateCompleteCustomerPublic',
                null, {}, function(){}, _w.taskContractError
            );

            $('#table-form-actions-prev').click(function () {

                App.Ajax.JSON({
                        "url"  : 'workspace/populate-complete-valuation-appointment-table',
                        "data" : {'currentPosition' : '-1','valuationId' : _w.customercompletevaluation.itemId}
                    },
                    $.proxy(function(response) {

                        //console.log('response',response.outputTableHeader);

                        $('#completeValuationGridColumnHeaders').html(response.outputTableHeader);

                        $('#completeValuationGridRowRepeater').html(response.outputTableBody);


                    },this),
                    $.proxy(function(response) {
                        console.log('App.Notification.remove Error', response);
                    },this)
                );
            });

            $('#table-form-actions-next').click(function () {

                App.Ajax.JSON({
                        "url"  : 'workspace/populate-complete-valuation-appointment-table',
                        "data" : {'currentPosition' : '+1','valuationId' : _w.customercompletevaluation.itemId}
                    },
                    $.proxy(function(response) {

                        //console.log('response',response.outputTableHeader);

                        $('#completeValuationGridColumnHeaders').html(response.outputTableHeader);

                        $('#completeValuationGridRowRepeater').html(response.outputTableBody);


                    },this),
                    $.proxy(function(response) {
                        console.log('App.Notification.remove Error', response);
                    },this)
                );
            });



            // Do a check here for the ie browser - if ie show upload file buttons
            // IE browsers prevent submitting files when the input field didn't receive a direct click

            if(navigator.appVersion.indexOf("MSIE ")!=-1)
            {
                $('#terms').parent().addClass("IE");
            }


            _w.customercompletevaluation.limited = false;
            _w.customercompletevaluation._setupValidation();

            $('.back-btn').on('click', function(){
                window.history.back();
            });

            $('#btnContinue1').click(function () {

                $('.btn-next').click();
            });

            $('#btnContinue2').click(function () {

                $('.btn-next').click();
            });

            $('#btnContinue3').click(function () {

            });
            $('#btnContinue4').click(function () {
                //$('#frmCustomerCompleteValuationView').submit();
                _w.customercompletevaluation._setupValidation();


                var data = _w.customercompletevaluation._prepValuationUpdateData();

                console.log('updateValuation '  + _w.customercompletevaluation.itemId + ' data',data);

                App.API.execTask(
                    'updateValuation:' + _w.customercompletevaluation.itemId, data, {},
                    _w.customercompletevaluation._onValuationUpdated,
                    _w.customercompletevaluation._onValuationFail
                );
            });
            $('.btn-prev').click($.proxy(function () {
                _w.customercompletevaluation.currentStep--;
            }, this));
            //$('.btn-next').click($.proxy(function () {
            //    console.log('button .btn-next','click');
            //
            //    $('.btn-next').prop('disabled', true);
            //    _w.customercompletevaluation.currentStep++;
            //    //_w.customercompletevaluation.validatePage(_w.customercompletevaluation.currentStep);
            //}, this));

            $('.btn-next').click($.proxy(function () {
                //console.log('button .btn-next','click');
                //console.log('button .btn-next _w.customervaluation.currentStep',_w.customervaluation.currentStep);
                $('.btn-next').prop('disabled', true);
                _w.customercompletevaluation.currentStep++;
                //_w.customercompletevaluation.validatePage(_w.customercompletevaluation.currentStep);
            }, this));

            $('#btnContinue2').hide();
            $('#btnContinue3').hide();

            $('#btnContinue4').prop('disabled', true);

            $('#terms').change($.proxy(function () {

                if($('#terms').is(':checked'))
                {
                    $('#btnContinue4').prop('disabled', false);
                }
                else
                {
                    $('#btnContinue4').prop('disabled', true);
                }
            }, this));

        },

        _onCustomerCompleteValuationViewDataReceived : function( response )
        {
            console.log('response.Data',response.Data);

            _w.customercompletevaluation.itemId = response.Data.id;
            _w.customercompletevaluation.itemData = response.Data;
            _w.customercompletevaluation.setValuationViewFormMeta(response.Data);
            _w.customercompletevaluation.ti.hydratePartial(_w.customercompletevaluation.formMeta);
            if (_w.customercompletevaluation.ti.published)
            {
                _w.customercompletevaluation._setupValidation();
            }
        },

        goToNext : function(profile,dateNo,valuatorNo)
        {
            //console.log('profile',profile);
            //console.log('dateNo',dateNo);

            App.Ajax.JSON({
                    "url"  : 'workspace/populate-complete-valuation-appointment-time-table',
                    "data" : {'profileId' : profile,'dateNo' : dateNo,'valuatorNo' : valuatorNo}
                },
                $.proxy(function(response) {

                    //console.log('goToNext response',response);


                    $('#valuatorSelected').val(profile);
                    $('#dateSelected').val(response.dateSelected);

                    $('#completeValuationGridColumnHeadersTime').html(response.outputTableHeader);

                    $('#completeValuationGridRowRepeaterTime').html(response.outputTableBody);

                    $('.btn-next').click();

                },this),
                $.proxy(function(response) {
                    console.log('App.Notification.remove Error', response);
                },this)
            );
        },

        goToFinish : function(timeSlotId,timeSlot)
        {
            //console.log('timeSlot',timeSlot);

            $('#timeSelected').val(timeSlot);
            $('#timeIdSelected').val(timeSlotId);

            var rules1 = {
                firstName: {required: true, minlength: 3},
                familyName: {required: true, minlength: 3},
                email: {required: true, email: true},
                mobile: {required: true, mobile: true},
                customerAddressStreet: {required: true},
                customerAddressStreetName: {required: true},
                customerAddressSuburb: {required: true},
                customerAddressCity: {required: true},
                customerAddressPostalCode: { required: true, digits: true }
            };
            $('#frmCustomerCompleteValuationView').validate({
                "rules": rules1,
                messages: {
                    firstName: {
                        minlength: "This field is required."
                    },
                    familyName: {
                        minlength: "This field is required."
                    },
                    email: {
                        required: "This field is required.",
                        email: "Please enter a valid<br/>email address."
                    },
                    customerAddressStreet : "This field is required.",
                    customerAddressStreetName : "This field is required.",
                    customerAddressSuburb : "This field is required.",
                    customerAddressCity : "This field is required.",
                    customerAddressPostalCode : {required: "This field is required."}
                },
                invalidHandler: function(event, validator) {
                    var errors = validator.numberOfInvalids();
                    if (0 < _w.customercompletevaluation.validations && errors) {
                        var message = errors == 1
                            ? 'You missed 1 field. It has been highlighted'
                            : 'You missed ' + errors + ' fields. They have been highlighted';
                        alert(message);
                    }
                    _w.customercompletevaluation.validations++;
                },
                submitHandler: function( form ) {
                    return;
                }
            });
            try {
                _w.customercompletevaluation.validations = 0;
                var formValid = $('#frmCustomerCompleteValuationView').valid();

                if(formValid)
                {
                    var confirmationOfpublicDealer = $('#publicDealer').val();
                    var confirmationOfpublicDealerContactNumber = $('#publicDealerContactNumber').val();

                    var confirmationOffirstName = $('#firstName').val();
                    var confirmationOffamilyName = $('#familyName').val();
                    var confirmationOfmobile = $('#mobile').val();
                    var confirmationOfemail = $('#email').val();

                    var confirmationOfcustomerAddressStreet = $('#customerAddressStreet').val();
                    var confirmationOfpublicustomerAddressStreetName = $('#customerAddressStreetName').val();
                    var confirmationOfcustomerAddressSuburb = $('#customerAddressSuburb').val();
                    var confirmationOfcustomerAddressCity = $('#customerAddressCity').val();
                    var confirmationOfcustomerAddressPostalCode = $('#customerAddressPostalCode').val();

                    var confirmationOfdateSelected = $('#dateSelected').val();
                    var confirmationOftimeSelected = $('#timeSelected').val();

                    var confirmationOfInfoHtml =
                        '<div class="span12">'
                        + '<h3>'
                        + confirmationOfpublicDealer
                        + ' ('
                        + confirmationOfpublicDealerContactNumber
                        + ')'
                        + '</h3>'

                        + '<br>'
                        + '<br>'

                        + '<h4>Date / Time:<h4>'
                        + '<br>'
                        + '<h5>' + confirmationOfdateSelected + '</h5>'
                        + '<h5>' + confirmationOftimeSelected + '</h5>'

                        + '<br>'
                        + '<br>'

                        + '<h4>Your Address:<h4>'
                        + '<br>'
                        + '<h5>' + confirmationOfcustomerAddressStreet + '</h5>'
                        + '<h5>' + confirmationOfpublicustomerAddressStreetName + '</h5>'
                        + '<h5>' + confirmationOfcustomerAddressSuburb + '</h5>'
                        + '<h5>' + confirmationOfcustomerAddressCity + '</h5>'
                        + '<h5>' + confirmationOfcustomerAddressPostalCode + '</h5>'

                        + '<br>'
                        + '<br>'

                        + '<h4>Email:<h4>'
                        + '<br>'
                        + '<h5>' + confirmationOfemail + '</h5>'
                        + '</div>';

                    $('#confirmationOfInfo').html(confirmationOfInfoHtml);

                    $('.btn-next').click();
                }

            } catch(err) {}
            $('label.error').remove();
            $('.valid').removeClass('valid');

            //$('.btn-next').click();
        },

        validatePage : function(step)
        {
            //console.log('validatePage step',step)

            var errors = false;

            switch (step)
            {
                case 1:
                    var fields = {
                        '#firstName': true,
                        '#familyName': true,
                        '#email': true,
                        '#mobile': true,
                        '#customerAddressStreet': true,
                        '#customerAddressStreetName': true,
                        '#customerAddressSuburb': true,
                        '#customerAddressCity': true,
                        '#customerAddressPostalCode': true
                    };
                    break;
            }

            for (var field in fields)
            {
                if ('' !== $(field).val() && null !== $(field).val())
                {
                    if (!$(field).valid())
                    {
                        $('.btn-next').prop('disabled', true);
                        $('#btnContinue' + step).prop('disabled', true);
                        return;
                    }
                }
                else if (fields[field])
                {
                    $('.btn-next').prop('disabled', true);
                    $('#btnContinue' + step).prop('disabled', true);
                    return;
                }

            }

            $('.btn-next').prop('disabled', false);
            $('#btnContinue' + step).prop('disabled', false);

        },

        setValuationViewFormMeta : function(data)
        {
            if (!data)
            {
                data = {"stock":{}};
            }
            else
            {
                $('#vehicleYear').val(data.stock.vehicleYear);
                $('#registrationNumber').val(data.stock.registrationNumber);
                $('#fuelType').val(data.stock.fuelType);
                $('#transmissionType').val(data.stock.transmissionType);

                $('#publicDealer').val(data.stock.company.name);
                $('#publicDealerContactNumber').val(null != data.stock.company.contact.office && '' != data.stock.company.contact.office ? data.stock.company.contact.office : data.stock.company.contact.mobile);
            }

            //console.log('data',data);

            _w.customercompletevaluation.formMeta = {
                'firstName' : {
                    type  : 'input',
                    id    : 'firstName',
                    title : 'Name',
                    value : data.firstName ? data.firstName : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customercompletevaluation.validatePage(1);
                    }
                },
                'familyName' : {
                    type  : 'input',
                    id    : 'familyName',
                    title : 'Surname',
                    value : data.familyName ? data.familyName : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customercompletevaluation.validatePage(1);
                    }
                },
                'email' : {
                    type  : 'input',
                    id    : 'email',
                    title : 'Email address',
                    value : data.email ? data.email : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customercompletevaluation.validatePage(1);
                    }
                },
                'mobile' : {
                    type  : 'mobile',
                    id    : 'mobile',
                    title : 'Mobile',
                    value : data.mobile ? data.mobile : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customercompletevaluation.validatePage(1);
                    }
                },
                'customerAddressStreet' : {
                    type  : 'input',
                    id    : 'customerAddressStreet',
                    title : 'Street/Unit/Building No',
                    value : data.customerAddressStreet ? data.customerAddressStreet : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customercompletevaluation.validatePage(1);
                    }
                },
                'customerAddressStreetName' : {
                    type  : 'input',
                    id    : 'customerAddressStreetName',
                    title : 'Street Name',
                    value : data.customerAddressStreetName ? data.customerAddressStreetName : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customercompletevaluation.validatePage(1);
                    }
                },
                'customerAddressSuburb' : {
                    type  : 'input',
                    id    : 'customerAddressSuburb',
                    title : 'Suburb / District',
                    value : data.customerAddressSuburb ? data.customerAddressSuburb : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customercompletevaluation.validatePage(1);
                    }
                },
                'customerAddressCity' : {
                    type  : 'input',
                    id    : 'customerAddressCity',
                    title : 'City / Town',
                    value : data.customerAddressCity ? data.customerAddressCity : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customercompletevaluation.validatePage(1);
                    }
                },
                'customerAddressPostalCode' : {
                    type  : 'input',
                    id    : 'customerAddressPostalCode',
                    title : 'Postal Code',
                    value : data.customerAddressPostalCode ? data.customerAddressPostalCode : '',
                    onChange    : function (evt) {
                        var value = $(evt.currentTarget).val();
                        if (null == value || '' == value)
                        {
                            return;
                        }
                        _w.customercompletevaluation.validatePage(1);
                    }
                }
            };
        },

        _listMakesModelsTypes : function( fromItemData, callback )
        {
        },

        _setupValidation : function ()
        {
            var rules = {
                firstName: {required: true, minlength: 3},
                familyName: {required: true, minlength: 3},
                email: {required: true, email: true},
                mobile: {required: true, mobile: true},
                customerAddressStreet: {required: true},
                customerAddressStreetName: {required: true},
                customerAddressSuburb: {required: true},
                customerAddressCity: {required: true},
                customerAddressPostalCode: { required: true, digits: true }
            };
            $('#frmCustomerCompleteValuationView').validate({
                "rules": rules,
                messages: {
                    firstName: {
                        minlength: "This field is required."
                    },
                    familyName: {
                        minlength: "This field is required."
                    },
                    email: {
                        required: "This field is required.",
                        email: "Please enter a valid<br/>email address."
                    },
                    customerAddressStreet : "This field is required.",
                    customerAddressStreetName : "This field is required.",
                    customerAddressSuburb : "This field is required.",
                    customerAddressCity : "This field is required.",
                    customerAddressPostalCode : {required: "This field is required."}
                },
                invalidHandler: function(event, validator) {
                    var errors = validator.numberOfInvalids();
                    if (0 < _w.customercompletevaluation.validations && errors) {
                        var message = errors == 1
                            ? 'You missed 1 field. It has been highlighted'
                            : 'You missed ' + errors + ' fields. They have been highlighted';
                        alert(message);
                    }
                    _w.customercompletevaluation.validations++;
                },
                submitHandler: function( form ) {
                    return;
                }
            });
            try {
                _w.customercompletevaluation.validations = 0;
                $('#frmCustomerCompleteValuationView').valid();
            } catch(err) {}
            $('label.error').remove();
            $('.valid').removeClass('valid');
        },


        _prepValuationUpdateData : function()
        {
            function isValidEmailAddress(emailAddress) {
                var pattern = new RegExp(/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i);
                return pattern.test(emailAddress);
            };

            var data = _w.customercompletevaluation.ti.harvest();

            data.valuatorId = $('#valuatorSelected').val();
            data.dateSelected = $('#dateSelected').val();
            data.timeIdSelected = $('#timeIdSelected').val();
            data.vehicleYear = $('#vehicleYear').val();
            data.registrationNumber = $('#registrationNumber').val();
            data.fuelType = $('#fuelType').val();
            data.transmissionType = $('#transmissionType').val();

            //console.log('data',data);

            var postData = {Stock:{}, Valuation:{}};
            var valuationFields = [
                "firstName","familyName","mobile", "email", "customerAddressStreet", "customerAddressStreetName", "customerAddressSuburb", "customerAddressCity", "customerAddressPostalCode"
            ];
            for (var field in data)
            {
                if (-1 == valuationFields.indexOf(field))
                {
                    postData.Stock[field] = data[field];
                }
                else
                {
                    postData.Valuation[field] = data[field];
                }
            }


            if( !isValidEmailAddress( postData.Valuation.email ) )
            {
                testEmail = postData.Valuation.email;
                //console.log("went through check", testEmail);
                postData.Valuation.email = null;
            }


            postData.Valuation.valuatorSelected = data.valuatorId;
            postData.Valuation.dateSelected = data.dateSelected;
            postData.Valuation.timeIdSelected = data.timeIdSelected;

            if ('' == postData.Valuation.email)
            {
                postData.Valuation.email = null;
            }

            return postData;
        },

        _onValuationUpdated : function( response )
        {
            //alert('Your vehicle has successfully been submitted.');
            window.location.hash = '/thankyouvaluation';

            //send customer valuation email
        },
        _onValuationFail : function( response )
        {
            console.log('_onValuationFail response',response);

            alert('Oops, something went wrong, please check your data carefully and try again.');
            //window.location.hash = '/public-landing';
        }

    };

})();