;(function(){

	window._w.disputeview = {

		itemId : null,
		itemData : null,
		formMeta : null,
		ti : null,

		onViewTemplateReady : function( template, event, eventData )
		{
			_w.disputeview.ti = _t[template];
			_w.disputeview.itemData = null;
			_w.disputeview.setDisputeViewFormMeta();
			_w.disputeview.ti.hydrate(_w.disputeview.formMeta);

			// Retrieve initial view data.
			_w.disputeview.itemId = App.Util.getUrlParam('id');
			App.API.getTask(
				'viewDispute:' + _w.disputeview.itemId, 'Dispute', 'Dispute.View', _w.disputeview.itemId,
				{'id':_w.disputeview.itemId}, _w.disputeview._onDisputeViewDataReceived, _w.taskContractError
			);
		},

		setDisputeViewFormMeta : function( data )
		{
			if (!data)
			{
				data = {};
			}
			_w.disputeview.formMeta = {
					'jobState' : {
						title       : 'Status',
						value       : data.jobState
					},
					'created' : {
						title       : 'Created',
						value       : data.created ? ((data.created).split(' '))[0] : ''
					},
					'vehicle' : {
						title       : 'Vehicle',
						value       : data.auction ? data.auction.stock.type.model.make.name
											+ ', ' + data.auction.stock.type.model.name
											+ ', ' + data.auction.stock.type.name
											+ ' (' + data.auction.stock.vehicleYear.name + ')'
										: ''
					},
					'complaint' : {
						title       : 'Complaint',
						value       : data.complaint
					},
					'resolution' : {
						title       : 'Resolution',
						value       : data.resolution
					},
					'plaintive' : {
						title       : 'Plaintiff',
						value       : data.fromCompany ? data.fromCompany.name : ''
					},
					'contact' : {
						title       : 'Contact person',
						value       : data.fromCompany
										? data.fromCompany.contact.firstName
												+ ' ' + data.fromCompany.contact.familyName
										: ''
					},
					'office' : {
						title       : 'Office',
						value       : data.fromCompany ? data.fromCompany.contact.office : ''
					},
					'mobile' : {
						title       : 'Mobile',
						value       : data.fromCompany ? data.fromCompany.contact.mobile : ''
					},
					'email' : {
						title       : 'Email',
						value       : data.fromCompany ? data.fromCompany.contact.email : ''
					}
			};
		},

		_onDisputeViewDataReceived : function( response )
		{
			_w.disputeview.itemId = response.Data.id;
			_w.disputeview.itemData = response.Data;
			console.log(response.Data);
			_w.disputeview.setDisputeViewFormMeta(response.Data);
			_w.disputeview.ti.hydrate(_w.disputeview.formMeta);
		}

	};

})();