;
(function () {

	window._w.valuationview = {
		itemId: null,
		itemData: null,
		formMeta: null,
		ti: null,
		limited: false,
		newItem: false,
		validations: 0,
		highestOfferId: false,
		priceGuideId: false,
		firstTimeCheck: true,
		firstTimeCheckYear: true,
		onValuationViewTemplateReady: function (template, event, eventData)
		{
			_w.valuationview.itemData = null;
			_w.valuationview.ti = _t[template];
			_w.valuationview.firstTimeCheck = true;
			_w.valuationview.firstTimeCheckYear = true;
			_w.valuationview.limited = ('limitedvaluationview' == template)
							? true
							: false;
			_w.valuationview.itemId = App.Util.getUrlParam('id');
			if (0 == _w.valuationview.itemId || null == _w.valuationview.itemId)
			{
				_w.valuationview.newItem = true;
				_w.valuationview.itemData = {stock: {}};
				_w.valuationview.firstTimeCheck = false;
				_w.valuationview.firstTimeCheckYear = false;
			}

			App.DataStore.setData('departments', [{"value": "New", "label": "New"}, {"value": "Used", "label": "Used"}]);
			App.DataStore.setData('sparekeys', [{"value": "1", "label": "Yes"}, {"value": "0", "label": "No"}]);
			App.DataStore.setData('yesno', [{"value": "1", "label": "Yes"}, {"value": "0", "label": "No"}]);



			/*_w.valuationview.setValuationViewFormMeta();
			 _w.valuationview.ti.hydrate(_w.valuationview.formMeta);*/

		},
		onValuationViewPublished: function (template, event, eventData)
		{
			_w.valuationview.ti = _t[template];
			_w.valuationview.limited = ('limitedvaluationview' == template)
							? true
							: false;
			_w.valuationview.setValuationViewFormMeta();
			_w.valuationview.ti.hydrate(_w.valuationview.formMeta);

			if (_w.valuationview.newItem)
			{
				_w.valuationview._setupValidation();
				$('#btnSaveAsSales').show();
				$('#btnSaveAsPending').show();
				$('#optSendToSales').show();
				$('#optSendToPg').show();
				$('#btnSendToStock').show();
				$('#btnUpdate').prop('disabled', false);
				$('#printValuationPdf').hide();


				//HPI Report Hide on New
				$('#requestHPIreport').hide();
                $('#requestHPIAccidentReport').hide();
				$('.hpiReport').hide();

				/*
				 * Permissions
				 */
				true == App.permissions.valuationCreateSales ? $('#sectionSelectValuator').show() : $('#sectionSelectValuator').hide();
				true == App.permissions.valuationCreatePriceguide ? $('#optSendToPg').show() : $('#optSendToPg').hide();
				true == App.permissions.valuationCreateComplete ? $('#optSendToSales').show() : $('#optSendToSales').hide();
				true == App.permissions.valuationCreateNew ? $('#btnUpdate').show() : $('#btnUpdate').hide();
				true == App.permissions.valuationCreateStock ? $('#btnSendToStock').show() : $('#btnSendToStock').hide();
				true == App.permissions.valuationCreatePending ? $('#btnSaveAsPending').show() : $('#btnSaveAsPending').hide();

				true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid + '_overAllowance').show() : $('#' + _w.valuationview.ti.tid + '_overAllowance').hide();
				true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid + '_standInValue').show() : $('#' + _w.valuationview.ti.tid + '_standInValue').hide();
				true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid + '_projectedRetail').show() : $('#' + _w.valuationview.ti.tid + '_projectedRetail').hide();
				true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid + '_plannedMargin').show() : $('#' + _w.valuationview.ti.tid + '_plannedMargin').hide();

				if (!App.permissions.valuationUpdateDamages)
				{
					$('.damages-form').hide();
				}
				else
				{
					$('.damages-form').show();
				}
				if (!App.permissions.valuationUpdateCoverReceived)
				{
					$('.cover-received-form').hide();
				}
				else
				{
					$('.cover-received-form').show();
				}
				
				if (!App.permissions.valuationUploadPhotos)
				{
					$('.photos-form').html('&nbsp;');
				}
			}



			$('#btnRequestHPI').click(function () {

				if ('' == $('#HPIusername').val() || '' == $('#HPIpin').val())
				{
					alert('Please enter a valid username and password.');
					return;
				}

				$('#HPIdropConfirm').slideToggle();
				$('#HPIresponse').html('');
			});

            $('#btnRequestHPIAccident').click(function () {

                if ('' == $('#HPIAccidentUsername').val() || '' == $('#HPIAccidentPin').val())
                {
                    alert('Please enter a valid username and password.');
                    return;
                }

                $('#HPIAccidentDropConfirm').slideToggle();
                $('#HPIAccidentResponse').html('');
            });


			App.Util.updateCheckboxStyle($('#acceptHPIdisclaimer'));
			$('#HPIbtnConfirm').click(function () {
				if ($('#engineNumber').val() == '') {
					alert('Please update the Vehicle Engine Number and try again');
					return;
				}
				if ($('#vinNumber').val() == '' && $('#registrationNumber').val() == '') {
					alert('Please update the Vin Number or the Registration Number and and try again');
					return;
				}
				if (!$('#acceptHPIdisclaimer').is(':checked'))
				{
					alert('Please accept the conditions before sending.');
					return;
				}
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				$('#HPIbtnConfirm').prop('disabled', true);

				var data = _w.valuationview._prepValuationUpdateData();
				App.API.execTask(
								'updateValuation:' + _w.valuationview.itemId, data, {},
								function ()
								{
									var task = _w.valuationview.limited
													? 'Valuation.LimitedUpdate'
													: 'Valuation.Update';
									App.API.getTask(
													'updateValuation:' + _w.valuationview.itemId, 'Valuation', task, _w.valuationview.itemId,
													{}, function () {
									}, _w.taskContractError
													);
									var user = $('#HPIusername').val();
									var pass = $('#HPIpin').val();

									App.API.getTask(
													'TransUnionForHPI', 'Stock', 'Utility.TransUnionForHPI', null,
													{'Filter': {'username': user, 'pass': pass, 'stock': _w.stock.Id}},
									function () {
										App.API.execTask(
														'TransUnionForHPI', {}, {},
														function (data)
														{
															$('#HPIdropConfirm').hide();
															if ('Success' == data.Status)
															{
																$('#HPIresponse').html('Success on HPI Report');
																alert('Success on HPI Report');
																App.DataStore.loadSelectListData(
																				'tuhpi', false, 'Stock', 'Tuhpi.List', null, {
																					"Filter":
																									{
																										"stock": _w.valuationview.itemData.stock.id,
																										"company": App.companyData.id
																									}
																				}, {}, function ()
																{
																	// data is retrieved
																	var tuHpiData = App.DataStore.getData('tuhpi');


                                                                    _w.valuationview._loadHpiReportData(tuHpiData);

																	//for (var i = 0; i < tuHpiData.length; i++)
																	//{
                                                                     //   var tuHpiId = tuHpiData[i].id;
                                                                     //   var tuHpiCreated = tuHpiData[i].created;
                                                                     //   var tuHpiType = tuHpiData[i].hpi_type;
																	//	if (tuHpiId)
																	//	{
																	//		$('#tuhpiDate').html(tuHpiCreated);
                                                                     //       $('#tuhpiType').html(tuHpiType);
																	//		$('#downloadTuhpi').show();
																	//		$('#HPIbtnConfirm').prop('disabled', true);
																	//		return;
																	//	}
																	//	else
																	//	{
																	//		$('#tuhpiDate').html('Not Requested Yet');
                                                                     //       $('#tuhpiType').html('Not Requested Yet');
																	//		$('#downloadTuhpi').hide();
																	//		$('#HPIbtnConfirm').prop('disabled', false);
																	//	}
																	//}
																});
															}
															else
															{
																$('#HPIresponse').html('API call to remote host failed. No data could be retrieved from remote service.');
																$('#HPIbtnConfirm').prop('disabled', false);
															}
														}, function (response)
										{
											alert(
															undefined != response.StatusReason
															? response.StatusReason
															: 'API call to remote host failed. No data could be retrieved from remote service.'
															);
											$('#HPIbtnConfirm').prop('disabled', false);
										}
										);
									}
									, _w.taskContractError
													);
								}, _w.taskExecError
								);
			});




            App.Util.updateCheckboxStyle($('#acceptHPIAccidentDisclaimer'));
            $('#HPIAccidentBtnConfirm').click(function () {
                if ($('#engineNumber').val() == '') {
                    alert('Please update the Vehicle Engine Number and try again');
                    return;
                }
                if ($('#vinNumber').val() == '' && $('#registrationNumber').val() == '') {
                    alert('Please update the Vin Number or the Registration Number and and try again');
                    return;
                }
                if (!$('#acceptHPIAccidentDisclaimer').is(':checked'))
                {
                    alert('Please accept the conditions before sending.');
                    return;
                }
                if (!$('#frmValuationView').valid())
                {
                    return;
                }
                $('#HPIAccidentBtnConfirm').prop('disabled', true);

                var data = _w.valuationview._prepValuationUpdateData();
                App.API.execTask(
                    'updateValuation:' + _w.valuationview.itemId, data, {},
                    function ()
                    {
                        var task = _w.valuationview.limited
                            ? 'Valuation.LimitedUpdate'
                            : 'Valuation.Update';
                        App.API.getTask(
                            'updateValuation:' + _w.valuationview.itemId, 'Valuation', task, _w.valuationview.itemId,
                            {}, function () {
                            }, _w.taskContractError
                        );
                        var user = $('#HPIAccidentUsername').val();
                        var pass = $('#HPIAccidentPin').val();

                        App.API.getTask(
                            'TransUnionForHPIAccident', 'Stock', 'Utility.TransUnionForHPIAccident', null,
                            {'Filter': {'username': user, 'pass': pass, 'stock': _w.stock.Id}},
                            function () {
                                App.API.execTask(
                                    'TransUnionForHPIAccident', {}, {},
                                    function (data)
                                    {
                                        $('#HPIAccidentDropConfirm').hide();
                                        if ('Success' == data.Status)
                                        {
                                            $('#HPIresponse').html('Success on HPI Report');
                                            alert('Success on HPI Report');
                                            App.DataStore.loadSelectListData(
                                                'tuhpi', false, 'Stock', 'Tuhpi.List', null, {
                                                    "Filter":
                                                    {
                                                        "stock": _w.valuationview.itemData.stock.id,
                                                        "company": App.companyData.id
                                                    }
                                                }, {}, function ()
                                                {
                                                    // data is retrieved
                                                    var tuHpiData = App.DataStore.getData('tuhpi');

                                                    _w.valuationview._loadHpiReportData(tuHpiData);

                                                    //for (var i = 0; i < tuHpiData.length; i++)
                                                    //{
                                                    //    var tuHpiId = tuHpiData[i].id;
                                                    //    var tuHpiCreated = tuHpiData[i].created;
                                                    //    var tuHpiType = tuHpiData[i].hpi_type;
                                                    //    if (tuHpiId)
                                                    //    {
                                                    //        $('#tuhpiDate').html(tuHpiCreated);
                                                    //        $('#tuhpiType').html(tuHpiType);
                                                    //        $('#downloadTuhpi').show();
                                                    //        $('#HPIAccidentBtnConfirm').prop('disabled', true);
                                                    //        return;
                                                    //    }
                                                    //    else
                                                    //    {
                                                    //        $('#tuhpiDate').html('Not Requested Yet');
                                                    //        $('#tuhpiType').html('Not Requested Yet');
                                                    //        $('#downloadTuhpi').hide();
                                                    //        $('#HPIAccidentBtnConfirm').prop('disabled', false);
                                                    //    }
                                                    //}
                                                });
                                        }
                                        else
                                        {
                                            $('#HPIAccidentResponse').html('API call to remote host failed. No data could be retrieved from remote service.');
                                            $('#HPIAccidentBtnConfirm').prop('disabled', false);
                                        }
                                    }, function (response)
                                    {
                                        alert(
                                            undefined != response.StatusReason
                                                ? response.StatusReason
                                                : 'API call to remote host failed. No data could be retrieved from remote service.'
                                        );
                                        $('#HPIAccidentBtnConfirm').prop('disabled', false);
                                    }
                                );
                            }
                            , _w.taskContractError
                        );
                    }, _w.taskExecError
                );
            });


			if (false != _w.valuationview.newItem)
			{
				$('#pricinghistory').hide();



			}

			if (false == _w.valuationview.newItem)
			{
				_w.valuationview.ti.hydrate({
					'gridPricingHistoryColumnHeaders': {
						constructor: 'GridColumnHeader',
						items: {
							Date: {
								id: 'gridPricingHistoryColumn_Date',
								title: 'Date',
							},
							Trade: {
								id: 'gridPricingHistoryColumn_Trade',
								title: 'Trade',
							},
							TotalRecon: {
								id: 'gridPricingHistoryColumn_totalRecon',
								title: 'Total Recon',
							},
							km: {
								id: 'gridPricingHistoryColumn_km',
								title: 'km',
							},
							PriceguideOffer: {
								id: 'gridPricingHistoryColumn_pricegOffer',
								title: 'Priceguide Offer',
							},
							AuctionWinningBid: {
								id: 'gridPricingHistoryColumn_auctionWinningBid',
								title: 'Auction Winning Bid',
							},
						}
					},
					'gridPricingHistoryRowRepeater': {}
				});
			}


			$('#btnUpdate').prop('disabled', true);
			$('#btnFetchTu').click(function () {
				if (!$('#vehicleYear').val()
								|| !$('#vehicleType').val())
				{
					alert('Vehicle year and type is required to fetch Trade and Retail pricing.');
					return;
				}
				$('#btnFetchTu').prop('disabled', true);
				App.API.getTask(
								'TransUnionFromMmCode', 'Stock', 'Utility.TransUnionFromMmCode', null,
								{}, _w.valuationview._onTuReady, _w.taskContractError
								);
			});
			$('#btnSendToDealDone').click(function () {
				var stockNo = $('#stockNumberDD').val();
				if (null == stockNo || '' == stockNo)
				{
					alert('Please enter a stock number.');
					return;
				}
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				if (!$('#acceptStockDDHPIdisclaimer').is(':checked'))
				{
					alert('Please accept the conditions before sending.');
					return;
				}
				if ('' == $('#mainImage').val())
				{
					alert('The main image is mandatory for moving a vehicle to Deal Done.');
					$('#img_mainImage').addClass('error');
					$('#img_mainImage').removeClass('valid');
					return;
				}
				else
				{
					$('#img_mainImage').removeClass('error');
					$('#img_mainImage').addClass('valid');
				}
				if ('' == $('#vinNumber').val())
				{
					alert('The VIN and Engine number is mandatory for moving a vehicle to Deal Done.');
					$('#vinNumber').addClass('error');
					$('#vinNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#vinNumber').removeClass('error');
					$('#vinNumber').addClass('valid');
				}
				if ('' == $('#engineNumber').val())
				{
					alert('The VIN and Engine number is mandatory for moving a vehicle to Deal Done.');
					$('#engineNumber').addClass('error');
					$('#engineNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#engineNumber').removeClass('error');
					$('#engineNumber').addClass('valid');
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnSendToDealDone').prop('disabled', true);
				$('#btnSendToDealNotDone').prop('disabled', true);
				var data = _w.valuationview._prepValuationUpdateData();

                data.Valuation.sendToStockFrom = "1";

				App.API.execTask(
								'updateValuation:' + _w.valuationview.itemId, data, {},
								function () {
									App.API.directRoute(
													'dealDoneOnValuation:' + _w.valuationview.itemId,
													'Valuation', 'Valuation.MoveToDealDone', _w.valuationview.itemId, {},
													_w.valuationview._onValuationUpdated, _w.taskExecError
													);
								}, _w.taskExecError
								);
			});
			$('#btnSendToDealNotDone').click(function () {
				if (!$('#frmValuationView').valid())
				{
					return;
				}

                if(7 == $('#dealNotDoneSelection').val() && '' == $('#dealNotDoneReason').val())
                {
                    alert('Please supply a reason for marking this deal as not done.');
                    return;
                }

				$('#btnUpdate').prop('disabled', true);
				$('#btnSendToDealDone').prop('disabled', true);
				$('#doSendToDealDone').prop('disabled', true);
				$('#doSendToDealNotDone').prop('disabled', true);
				var data = _w.valuationview._prepValuationUpdateData();
				App.API.execTask(
								'updateValuation:' + _w.valuationview.itemId, data, {},
								function () {
									App.API.directRoute(
													'dealNotDoneOnValuation:' + _w.valuationview.itemId,
													'Valuation', 'Valuation.MoveToDealNotDone', _w.valuationview.itemId, {},
													_w.valuationview._onValuationUpdated, _w.taskExecError
													);
								}, _w.taskExecError
								);
			});
			$('#doAcceptOffer').click(function () {
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnAcceptOffer').prop('disabled', true);
				$('#btnKeepForStock').prop('disabled', true);
				var data = _w.valuationview._prepValuationUpdateData();
				App.API.execTask(
								'updateValuation:' + _w.valuationview.itemId, data, {},
								function () {
									App.API.directRoute(
													'offerAcceptedOnValuation:' + _w.valuationview.itemId,
													'Valuation', 'Valuation.MoveToOfferAccepted', _w.valuationview.itemId, {},
													_w.valuationview._onValuationUpdated, _w.taskExecError
													);
								}, _w.taskExecError
								);
			});
			$('#btnKeepForStock').click(function () {
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnAcceptOffer').prop('disabled', true);
				$('#btnKeepForStock').prop('disabled', true);
				var data = _w.valuationview._prepValuationUpdateData();
				App.API.execTask(
								'updateValuation:' + _w.valuationview.itemId, data, {},
								function () {
									App.API.directRoute(
													'keepForStockOnValuation:' + _w.valuationview.itemId,
													'Valuation', 'Valuation.MoveToKeepForStock', _w.valuationview.itemId, {},
													_w.valuationview._onValuationUpdated, _w.taskExecError
													);
								}, _w.taskExecError
								);
			});
			$('#btnArchive').click(function () {
				App.API.directRoute(
								'archiveValuation:' + _w.valuationview.itemId,
								'Valuation', 'Valuation.MoveToArchive', _w.valuationview.itemId, {},
								_w.valuationview._onValuationUpdated, _w.taskExecError
								);
			});
			$('#btnUnarchive').click(function () {
				App.API.directRoute(
								'unarchiveValuation:' + _w.valuationview.itemId,
								'Valuation', 'Valuation.UnArchive', _w.valuationview.itemId, {},
								_w.valuationview._onValuationUpdated, _w.taskExecError
								);
			});
			$('#btnSaveAsPending').click(function () {
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnSendToSales').prop('disabled', true);
				$('#btnSaveAsPending').prop('disabled', true);
				$('#doSendToStock').prop('disabled', true);
				$('#btnSendToPg').prop('disabled', true);
				if (_w.valuationview.newItem)
				{
					_w.valuationview._updatePrice(function () {
						var data = _w.valuationview._prepValuationUpdateData();
						App.API.getTask(
										'createValuationPending', 'Valuation', 'Valuation.CreatePending',
										null, {}, $.proxy(function (data) {
							App.API.execTask(
											'createValuationPending', data, {},
											_w.valuationview._onValuationUpdated, _w.taskExecError
											);
						}, this, data), _w.taskContractError
										);
					});
				}
				else
				{
					_w.valuationview._routeToPending();
				}
			});
			$('#btnSaveAsSales').click(function () {
				var valuators = $('#valuators').val();
				if (null == valuators)
				{
					alert('Please select at least one valuator.');
					return;
				}
				if (!$('#frmValuationView').valid())
				{
					return;
				}

				$('#btnSaveAsSales').prop('disabled', true);
				$('#btnUpdate').prop('disabled', true);
				$('#btnSendToSales').prop('disabled', true);
				$('#btnSaveAsPending').prop('disabled', true);
				$('#doSendToStock').prop('disabled', true);
				$('#btnSendToPg').prop('disabled', true);
				if (_w.valuationview.newItem)
				{
					_w.valuationview._updatePrice(function () {
						var data = _w.valuationview._prepValuationUpdateData();
						var valuators = $('#valuators').val();
						data.Valuation.valuators = [];
						for (var i = 0; i < valuators.length; i++)
						{
							data.Valuation.valuators.push({id: valuators[i]});
						}
						App.API.getTask(
										'createValuationNew', 'Valuation', 'Valuation.CreateNew',
										null, {}, $.proxy(function (data) {
							App.API.execTask(
											'createValuationNew', data, {},
											_w.valuationview._onValuationUpdated, _w.taskExecError
											);
						}, this, data), _w.taskContractError
										);
					});
				}
				else
				{
					var data = _w.valuationview._prepValuationUpdateData();
					var valuators = $('#valuators').val();
					data.Valuation.valuators = [];
					for (var i = 0; i < valuators.length; i++)
					{
						data.Valuation.valuators.push({id: valuators[i]});
					}
					App.API.execTask(
									'updateValuation:' + _w.valuationview.itemId, data, {},
									_w.valuationview._onValuationUpdated, _w.taskExecError
									);
				}
			});
			$('#btnSendToSales').click(function () {
				var profile = $('#salesProfile').val();
				var amount = $('#salesAmountOffered').val();
				if (null == profile || '' == amount)
				{
					alert('Please select Sales person and enter an Amount.');
					return;
				}
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnSendToSales').prop('disabled', true);
				$('#btnSaveAsPending').prop('disabled', true);
				$('#doSendToStock').prop('disabled', true);
				$('#btnSendToPg').prop('disabled', true);
				if (_w.valuationview.newItem)
				{
					_w.valuationview._updatePrice(function () {
						var data = _w.valuationview._prepValuationUpdateData();
						data.Valuation.amountOffered = amount;
						App.API.getTask(
										'createValuationComplete', 'Valuation', 'Valuation.CreateComplete',
										null, {}, $.proxy(function (data) {
							App.API.execTask(
											'createValuationComplete', data, {},
											_w.valuationview._onValuationUpdated, _w.taskExecError
											);
						}, this, data), _w.taskContractError
										);
					});
				}
				else
				{
					if ('Price Guide' == _w.valuationview.itemData.jobState)
					{
						App.API.getTask(
										'sendToSalesFull:' + _w.valuationview.itemId, 'Valuation', 'Valuation.SendToSalesFull', _w.valuationview.itemId,
										{}, function () {
							var data = _w.valuationview._prepValuationUpdateData();
							data.Valuation.amountOffered = $('#salesAmountOffered').val();
							App.API.execTask(
											'sendToSalesFull:' + _w.valuationview.itemId, data, {},
											_w.valuationview._onValuationUpdated, _w.taskExecError
											);
						}, _w.taskContractError
										);
					}
					else
					{
						_w.valuationview._routeToComplete();
					}
				}
			});

            $('#btnSendToCustomer').click(function () {
                var amount = $('#customerAmountOffered').val();
                if ('' == amount)
                {
                    alert('Please enter an Amount.');
                    return;
                }
                if (!$('#frmValuationView').valid())
                {
                    return;
                }
                $('#btnUpdate').prop('disabled', true);
                $('#btnSendToSales').prop('disabled', true);
                $('#btnSaveAsPending').prop('disabled', true);
                $('#doSendToStock').prop('disabled', true);
                $('#btnSendToPg').prop('disabled', true);
                if (_w.valuationview.newItem)
                {

                    _w.valuationview._updatePrice(function () {
                        var data = _w.valuationview._prepValuationUpdateData();
                        data.Valuation.amountOffered = amount;
                        App.API.getTask(
                            'createCustomerValuationComplete', 'Valuation', 'Valuation.CreateCompleteSendToCustomer',
                            null, {}, $.proxy(function (data) {
                                App.API.execTask(
                                    'createCustomerValuationComplete', data, {},
                                    _w.valuationview._onValuationUpdated, _w.taskExecError
                                );
                            }, this, data), _w.taskContractError
                        );
                    });
                }
                else
                {
                    if ('Price Guide' == _w.valuationview.itemData.jobState)
                    {
                        App.API.getTask(
                            'sendToCustomerFull:' + _w.valuationview.itemId, 'Valuation', 'Valuation.SendToCustomerFull', _w.valuationview.itemId,
                            {}, function () {
                                var data = _w.valuationview._prepValuationUpdateData();
                                data.Valuation.amountOffered = $('#salesAmountOffered').val();
                                App.API.execTask(
                                    'sendToCustomerFull:' + _w.valuationview.itemId, data, {},
                                    _w.valuationview._onValuationUpdated, _w.taskExecError
                                );
                            }, _w.taskContractError
                        );
                    }
                    else
                    {
                        _w.valuationview._routeToCompleteCustomer();
                    }

                }
            });

			App.Util.updateCheckboxStyle($('#acceptStockHPIdisclaimer'));
			App.Util.updateCheckboxStyle($('#acceptStockDDHPIdisclaimer'));
			$('#doSendToStock').click(function () {
				var stockNo = $('#stockNumber').val();
				if (null == stockNo || '' == stockNo)
				{
					alert('Please enter a stock number.');
					return;
				}
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				if (!$('#acceptStockHPIdisclaimer').is(':checked'))
				{
					alert('Please accept the conditions before sending.');
					return;
				}

				if ('' == $('#mainImage').val())
				{
					alert('The main image is mandatory for moving a vehicle to stock.');
					$('#img_mainImage').addClass('error');
					$('#img_mainImage').removeClass('valid');
					return;
				}
				else
				{
					$('#img_mainImage').removeClass('error');
					$('#img_mainImage').addClass('valid');
				}
				if ('' == $('#registrationNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to stock.');
					$('#registrationNumber').addClass('error');
					$('#registrationNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#registrationNumber').removeClass('error');
					$('#registrationNumber').addClass('valid');
				}
				if ('' == $('#vinNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to stock.');
					$('#vinNumber').addClass('error');
					$('#vinNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#vinNumber').removeClass('error');
					$('#vinNumber').addClass('valid');
				}
				if ('' == $('#engineNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to stock.');
					$('#engineNumber').addClass('error');
					$('#engineNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#engineNumber').removeClass('error');
					$('#engineNumber').addClass('valid');
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnSendToSales').prop('disabled', true);
				$('#btnSaveAsPending').prop('disabled', true);
				$('#doSendToStock').prop('disabled', true);
				$('#btnSendToPg').prop('disabled', true);

				if (_w.valuationview.newItem)
				{
					_w.valuationview._updatePrice(function () {
						var data = _w.valuationview._prepValuationUpdateData();

                        data.Valuation.sendToStockFrom = "2";

                        App.API.getTask(
                            'createValuationStock', 'Valuation', 'Valuation.CreateStock',
                            null, {}, $.proxy(function (data) {
                                App.API.execTask(
                                    'createValuationStock', data, {},
                                    _w.valuationview._onValuationUpdated, _w.taskExecError
                                );
                            }, this, data), _w.taskContractError
                        );

					});

				}
				else
				{
                    var data = _w.valuationview._prepValuationUpdateData();
                    data.Valuation.sendToStockFrom = "2";

                    App.API.execTask(
                        'updateValuation:' + _w.valuationview.itemId, data, {},
                        function () {

                            _w.valuationview._routeToStock();

                            //App.API.directRoute(
                            //    'sendToStockValuation:' + _w.valuationview.itemId,
                            //    'Valuation', 'Valuation.SendToStock', _w.valuationview.itemId, {},
                            //    _w.valuationview._onValuationUpdated, _w.taskExecError
                            //);
                        }, _w.taskExecError
                    );

                    //App.API.execTask(
                     //   'updateValuation:' + _w.valuationview.itemId, data, {},
                     //   _w.valuationview._onValuationUpdated, _w.taskExecError
                    //);
                    //
					//_w.valuationview._routeToStock();
				}
			});
			App.Util.updateCheckboxStyle($('#acceptPgHPIdisclaimer'));
			$('#btnSendToPg').click(function () {
				var clubs = $('#clubs').val();
				if (null == clubs)
				{
					alert('Please select at least one club.');
					return;
				}
				if (!$('#acceptPgHPIdisclaimer').is(':checked'))
				{
					alert('Please accept the conditions before sending.');
					return;
				}
				if ('' == $('#registrationNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to price guide.');
					$('#registrationNumber').addClass('error');
					$('#registrationNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#registrationNumber').removeClass('error');
					$('#registrationNumber').addClass('valid');
				}
				if ('' == $('#vinNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to price guide.');
					$('#vinNumber').addClass('error');
					$('#vinNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#vinNumber').removeClass('error');
					$('#vinNumber').addClass('valid');
				}
				if ('' == $('#engineNumber').val())
				{
					alert('The Registration, VIN and Engine number is mandatory for moving a vehicle to price guide.');
					$('#engineNumber').addClass('error');
					$('#engineNumber').removeClass('valid');
					return;
				}
				else
				{
					$('#engineNumber').removeClass('error');
					$('#engineNumber').addClass('valid');
				}
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnSendToSales').prop('disabled', true);
				$('#btnSaveAsPending').prop('disabled', true);
				$('#doSendToStock').prop('disabled', true);
				$('#btnSendToPg').prop('disabled', true);
				if (_w.valuationview.newItem)
				{
					_w.valuationview._updatePrice(function () {
						var data = _w.valuationview._prepValuationUpdateData();
						data.Context = {clubs: []};
						var clubList = $('#clubs').val();
						for (var i = 0; i < clubList.length; i++)
						{
							data.Context.clubs.push({id: clubList[i]});
						}
						App.API.getTask(
										'createValuationPriceGuide', 'Valuation', 'Valuation.CreatePriceGuide',
										null, {}, $.proxy(function (data) {
							App.API.execTask(
											'createValuationPriceGuide', data, {},
											_w.valuationview._onValuationUpdated, _w.taskExecError
											);
						}, this, data), _w.taskContractError
										);
					});
				}
				else
				{
					_w.valuationview._routeToPg();
				}
			});

			$('.back-btn').on('click', function () {
				window.history.back();
			});

			_w.valuationview.itemId = App.Util.getUrlParam('id');
			if (0 == _w.valuationview.itemId || null == _w.valuationview.itemId)
			{
				_w.valuationview.newItem = true;
				_w.valuationview.itemData = {stock: {}};

                App.DataStore.loadSelectListData(
                    'years', false, 'Stock', 'Year.SelectList', null,
                    {}
                );
                App.DataStore.loadSelectListData(
                    'categories', false, 'Stock', 'Category.SelectList', null,
                    {}
                );

                App.DataStore.loadSelectListData(
                    'fuelTypes', false, 'Stock', 'FuelType.SelectList', null,
                    {}
                );
                App.DataStore.loadSelectListData(
                    'transmissionTypes', false, 'Stock', 'TransmissionType.SelectList', null,
                    {}
                );
                App.DataStore.loadSelectListData(
                    'damages', false, 'Stock', 'Damage.SelectList', null,
                    {}
                );
                App.DataStore.loadSelectListData(
                    'accessories', false, 'Stock', 'Accessory.SelectList', null,
                    {}
                );

				App.DataStore.loadSelectListGroup([
					//{dataId: 'years', isStatic: true, workspace: 'Stock', task: 'Year.SelectList'},
					//{dataId: 'categories', isStatic: true, workspace: 'Stock', task: 'Category.SelectList'},
					{dataId: 'conditions', isStatic: true, workspace: 'Stock', task: 'Condition.SelectList'},
					{dataId: 'exteriorColours', isStatic: true, workspace: 'Stock', task: 'ExteriorColour.SelectList'},
					{dataId: 'interiorColours', isStatic: true, workspace: 'Stock', task: 'InteriorColour.SelectList'},
					{dataId: 'upholsteries', isStatic: true, workspace: 'Stock', task: 'Upholstery.SelectList'},
					{dataId: 'papers', isStatic: true, workspace: 'Stock', task: 'Paper.SelectList'},
					{dataId: 'natis', isStatic: true, workspace: 'Stock', task: 'Natis.SelectList'},
					{dataId: 'fsh', isStatic: true, workspace: 'Stock', task: 'FullServiceHistory.SelectList'},
					//{dataId: 'fuelTypes', isStatic: true, workspace: 'Stock', task: 'FuelType.SelectList'},
					//{dataId: 'transmissionTypes', isStatic: true, workspace: 'Stock', task: 'TransmissionType.SelectList'},
					//{dataId: 'damages', isStatic: true, workspace: 'Stock', task: 'Damage.SelectList'},
					//{dataId: 'accessories', isStatic: true, workspace: 'Stock', task: 'Accessory.SelectList'},
					{dataId: 'clubs', isStatic: true, workspace: 'PriceGuide', task: 'Club.SelectList'},
					{dataId: 'valuators', isStatic: true, workspace: 'User', task: 'Profile.ValuatorList'},
					//{dataId: 'sales', isStatic: true, workspace: 'User', task: 'Profile.SalesList'},
					{dataId: 'regions', isStatic: true, workspace: 'Location', task: 'Region.SelectList'},
				]);
				App.DataStore.loadSelectListData(
								'sales', false, 'User', 'Profile.SalesList', null, {}
				);
                App.DataStore.loadSelectListData(
                    'dealNotDoneSelections', false, 'Valuation', 'Valuation.DealNotDoneSelection', null,
                    {}
                );


			}
			else
			{
				_w.valuationview.newItem = false;
				var task = _w.valuationview.limited
								? 'Valuation.LimitedUpdate'
								: 'Valuation.Update';
				App.API.getTask(
								'updateValuation:' + _w.valuationview.itemId, 'Valuation', task, _w.valuationview.itemId,
								{}, $.proxy(_w.valuationview._onValuationViewDataReceived, _w.valuationview), _w.taskContractError
								);
				setTimeout(function () {
					if (null == _w.valuationview.itemData)
					{
						var task = _w.valuationview.limited
										? 'Valuation.LimitedUpdate'
										: 'Valuation.Update';
						App.API.getTask(
										'updateValuation:' + _w.valuationview.itemId, 'Valuation', task, _w.valuationview.itemId,
										{}, $.proxy(_w.valuationview._onValuationViewDataReceived, _w.valuationview), _w.taskContractError
										);
					}
				}, 3000);
                App.DataStore.loadSelectListData(
                    'dealNotDoneSelections', false, 'Valuation', 'Valuation.DealNotDoneSelection', null,
                    {}
                );
			}
		},
		loadHistoricalGrid: function (contract, data, options)
		{
			if (_w.valuationview.itemData != null)
			{
				if (null != App.API.taskContract('gridStockHistory'))
				{
					App.API.execTask(
									'gridStockHistory', {Grid: {Filter: {"PricingHistory.stockId": _w.valuationview.itemData.stock.id}}}, options,
									_w.valuationview._onHistoryGridDataReceived, function () {
									}
					);
				}
			}
		},
		_onHistoryGridDataReceived: function (response)
		{
			_w.valuationview.gridStatus = 'Active';
			_w.valuationview.ti.hydrateParam('gridPricingHistoryRowRepeater', {});
			var gridData = [];

			if (_w.valuationview.itemData == null || response.Data.DataSet == undefined || response.Data.DataSet.length == 0 )
			{
				$('#pricing_history_none_found').show();
				$('#PHColumnHeaders').hide();
			}
			else
			{
				$('#pricing_history_none_found').hide();
				$('#PHColumnHeaders').show();
			}

			if(response.Data.DataSet != undefined)
			{
				for (var i = 0; i < response.Data.DataSet.length; i++)
					{
						var row = response.Data.DataSet[i];

						gridData.push({
							prepend: {
								Trade: 'R ',
								TotalRecon: 'R ',
								PriceguideOffer: 'R ',
								AuctionWinningBid: 'R '
							},
							style: {
								Date: '',
								Trade: '',
								TotalRecon: '',
								km: '',
								PriceguideOffer: '',
								AuctionWinningBid: '',
							},
							items: {
								'Date': row.date,
								'Trade': row.trade,
								'TotalRecon': row.totalRecon,
								'KM': row.km,
								'PriceguideOffer': row.pricegOffer,
								'AuctionWinningBid': row.auctionWinningBid,
							}
						});
					}
				
				_w.valuationview.ti.hydrateParam('gridPricingHistoryRowRepeater', {
					constructor: 'GridDataRow',
					items: gridData
				});
				response.Data.Meta.bind = _w.valuationview.pageStockGrid;
				
			} 	 
						
		},
		_routeToPg: function ()
		{
			App.API.getRoute(
							'sendToPg:' + _w.valuationview.itemId, 'Valuation', 'Valuation.SendToPriceGuide', _w.valuationview.itemId,
							{}, function () {
				var data = _w.valuationview._prepValuationUpdateData();
				data.Context = {clubs: []};
				var clubList = $('#clubs').val();
				for (var i = 0; i < clubList.length; i++)
				{
					data.Context.clubs.push({id: clubList[i]});
				}
				App.API.execRoute(
								'sendToPg:' + _w.valuationview.itemId, data, {},
								_w.valuationview._onValuationUpdated, _w.taskExecError
								);
			}, _w.taskContractError
							);
		},
		_routeToPending: function ()
		{
			App.API.getRoute(
							'sendToPending:' + _w.valuationview.itemId, 'Valuation', 'Valuation.MoveToPending', _w.valuationview.itemId,
							{}, function () {
				var data = _w.valuationview._prepValuationUpdateData();
				App.API.execRoute(
								'sendToPending:' + _w.valuationview.itemId, data, {},
								_w.valuationview._onValuationUpdated, _w.taskExecError
								);
			}, _w.taskContractError
							);
		},
		_routeToComplete: function ()
		{
			App.API.getRoute(
							'sendToComplete:' + _w.valuationview.itemId, 'Valuation', 'Valuation.MoveToComplete', _w.valuationview.itemId,
							{}, function () {
				var data = _w.valuationview._prepValuationUpdateData();


                    //if('' !=  $('#customerAmountOffered').val() && 0 ==  $('#salesAmountOffered').val())
                    //{
                    //    data.Valuation.amountOffered = $('#customerAmountOffered').val();
                    //}
                    //if('' !=  $('#salesAmountOffered').val() && 0 ==  $('#customerAmountOffered').val())
                    //{
                    //    data.Valuation.amountOffered = $('#salesAmountOffered').val();
                    //}

                    if(0 !=  $('#customerAmountOffered').val() && 0 ==  $('#salesAmountOffered').val())
                    {
                        data.Valuation.amountOffered = $('#customerAmountOffered').val();
                    }
                    else
                    {
                        data.Valuation.amountOffered = $('#salesAmountOffered').val();
                    }

				//data.Valuation.amountOffered = $('#salesAmountOffered').val();
				App.API.execRoute(
								'sendToComplete:' + _w.valuationview.itemId, data, {},
								_w.valuationview._onValuationUpdated, _w.taskExecError
								);
			}, _w.taskContractError
							);
		},

        _routeToCompleteCustomer: function ()
        {
            App.API.getRoute(
                'sendToCompleteCustomer:' + _w.valuationview.itemId, 'Valuation', 'Valuation.MoveToCustomerComplete', _w.valuationview.itemId,
                {}, function () {
                    var data = _w.valuationview._prepValuationUpdateData();


                    //if(0 !=  $('#customerAmountOffered').val() && 0 ==  $('#salesAmountOffered').val())
                    //{
                    //    data.Valuation.amountOffered = $('#customerAmountOffered').val();
                    //}
                    //if(0 !=  $('#salesAmountOffered').val() && 0 ==  $('#customerAmountOffered').val())
                    //{
                    //    data.Valuation.amountOffered = $('#salesAmountOffered').val();
                    //}

                    if(0 !=  $('#customerAmountOffered').val() && 0 ==  $('#salesAmountOffered').val())
                    {
                        data.Valuation.amountOffered = $('#customerAmountOffered').val();
                    }
                    else
                    {
                        data.Valuation.amountOffered = $('#salesAmountOffered').val();
                    }

                    //data.Valuation.amountOffered = $('#salesAmountOffered').val();
                    App.API.execRoute(
                        'sendToCompleteCustomer:' + _w.valuationview.itemId, data, {},
                        _w.valuationview._onValuationUpdated, _w.taskExecError
                    );
                }, _w.taskContractError
            );
        },
		_routeToStock: function ()
		{
			App.API.getRoute(
							'sendToStock:' + _w.valuationview.itemId, 'Valuation', 'Valuation.SendToStock', _w.valuationview.itemId,
							{}, function () {
				var data = _w.valuationview._prepValuationUpdateData();

				App.API.execRoute(
								'sendToStock:' + _w.valuationview.itemId, data, {},
								_w.valuationview._onValuationUpdated, _w.taskExecError
								);
			}, _w.taskContractError
							);
		},
		setValuationViewFormMeta: function (data)
		{

			var damages = {};
			var newtitle = 'Amount offered';


			if ('Dealership Sales' == App.permissions.name)
			{
				newtitle = "Manager's offer";
			}

			if (undefined != data && undefined != data.stock)
			{

				//console.log("data.stock.id", data.stock.id);

				_w.stock.Id = data.stock.id;

				for (var i = 0; i < data.stock.damages.length; i++)
				{
					damages['d' + data.stock.damages[i].damage] = data.stock.damages[i].amount;
				}
			}
			else
			{
				data = {"stock": {}};
			}

			_w.valuationview.formMeta = {
                'vehicleYear': {
                    type: 'select',
                    id: 'vehicleYear',
                    title: 'Year',
                    dataStoreId: 'years',
                    value: data.stock.vehicleYear ? data.stock.vehicleYear : '',
                    onChange: function () {
                        if (_w.valuationview.firstTimeCheckYear != true) {
                            _w.valuationview._listMakesModelsTypes(false, function () {

                            });
                        }
                        _w.valuationview.firstTimeCheckYear = false;
                    }
                },
                'category': {
                    type: 'select',
                    id: 'vehicleCategory',
                    title: 'Category',
                    dataStoreId: 'categories',
                    value: data.stock.type ? data.stock.type.category.id : '',
                    onChange: function () {
					    if ($(this).val() == 8) {
                            $('#retailPrice').val('');
                            $('#tradePrice').val('');
                            $('#listPrice').val('');
                            _w.valuationview.ti.hydrateParam('infRetailPrice', 'R ' + +'.00');
                            _w.valuationview.ti.hydrateParam('infTradePrice', 'R ' + +'.00');
                            _w.valuationview.ti.hydrateParam('infListPrice', 'R ' + +'.00');
                        }


                        if ($(this).val() == 8 && _w.valuationview.itemId == 0) {
                            $('#mmCode').html("Other");
                        }
                        if (!App.DataStore.getItem('BuildSelect:vehicleCategory', false)) {
                            if (_w.valuationview.itemData) {


                                //_w.valuationview.itemData.stock.type.category.id = $('#vehicleCategory').val();
                                if (undefined != _w.valuationview.itemData.stock && undefined != _w.valuationview.itemData.stock.type && undefined != _w.valuationview.itemData.stock.type.category) {
                                    _w.valuationview.itemData.stock.type.category.id = $('#vehicleCategory').val();
                                }
                                _w.valuationview._listMakesModelsTypes();
                            }
                        }
                        $('#' + _w.valuationview.ti.tid + '_makeManual').hide();
                        $('#' + _w.valuationview.ti.tid + '_modelManual').hide();
                        $('#' + _w.valuationview.ti.tid + '_typeManual').hide();
                        $('#makeManual').val('');
                        $('#modelManual').val('');
                        $('#typeManual').val('');
                        $('#' + _w.valuationview.ti.tid + '_make').show();
                        $('#' + _w.valuationview.ti.tid + '_model').show();
                        $('#' + _w.valuationview.ti.tid + '_type').show();
                    }
                },
                'make': {
                    type: 'select',
                    id: 'vehicleMake',
                    title: 'Vehicle Make',
                    dataStoreId: 'makes',
                    value: data.stock.type ? data.stock.type.model.make.id : '',
                    onChange: function () {
                        if (!App.DataStore.getItem('BuildSelect:vehicleMake', false)) {

                            $('#vehicleMakeManual').val('');
                            $('#vehicleModelManual').val('');
                            $('#vehicleTypeManual').val('');
                            if (-1 == $('#vehicleMake').val()) {
                                $('#' + _w.valuationview.ti.tid + '_make').hide();
                                $('#' + _w.valuationview.ti.tid + '_model').hide();
                                $('#' + _w.valuationview.ti.tid + '_type').hide();
                                $('#' + _w.valuationview.ti.tid + '_makeManual').show();
                                $('#' + _w.valuationview.ti.tid + '_modelManual').show();
                                $('#' + _w.valuationview.ti.tid + '_typeManual').show();
                                //$('#makeManual').val(''); vehicleMakeManual
                                //$('#modelManual').val('');
                                //$('#typeManual').val('');
                            }
                            else {
                                $('#' + _w.valuationview.ti.tid + '_makeManual').hide();
                                $('#' + _w.valuationview.ti.tid + '_modelManual').hide();
                                $('#' + _w.valuationview.ti.tid + '_typeManual').hide();
                                $('#' + _w.valuationview.ti.tid + '_make').show();
                                $('#' + _w.valuationview.ti.tid + '_model').show();
                                $('#' + _w.valuationview.ti.tid + '_type').show();
                                if (_w.valuationview.itemData) {


                                    if (undefined != _w.valuationview.itemData.stock && undefined != _w.valuationview.itemData.stock.type && undefined != _w.valuationview.itemData.stock.type.model) {
                                        //console.log("_w.valuationview.itemData", _w.valuationview.itemData);
                                        _w.valuationview.itemData.stock.type.model.make.id = $('#vehicleMake').val();
                                    }

                                    _w.valuationview._listMakesModelsTypes();
                                }
                            }

                        }
                    }
                },
                'model': {
                    type: 'select',
                    id: 'vehicleModel',
                    title: 'Vehicle Model',
                    dataStoreId: 'models',
                    value: data.stock.type ? data.stock.type.model.id : '',
                    onChange: function () {
                        if (!App.DataStore.getItem('BuildSelect:vehicleModel', false)) {

                            $('#vehicleModelManual').val('');
                            $('#vehicleTypeManual').val('');
                            if (-1 == $('#vehicleModel').val()) {
                                $('#' + _w.valuationview.ti.tid + '_model').hide();
                                $('#' + _w.valuationview.ti.tid + '_type').hide();
                                $('#' + _w.valuationview.ti.tid + '_modelManual').show();
                                $('#' + _w.valuationview.ti.tid + '_typeManual').show();
                            }
                            else {
                                $('#' + _w.valuationview.ti.tid + '_modelManual').hide();
                                $('#' + _w.valuationview.ti.tid + '_typeManual').hide();
                                $('#' + _w.valuationview.ti.tid + '_model').show();
                                $('#' + _w.valuationview.ti.tid + '_type').show();

                                if (_w.valuationview.itemData) {
                                    if (undefined != _w.valuationview.itemData.stock && undefined != _w.valuationview.itemData.stock.type && undefined != _w.valuationview.itemData.stock.type.model) {
                                        _w.valuationview.itemData.stock.type.model.id = $('#vehicleModel').val();
                                    }
                                    _w.valuationview._listMakesModelsTypes();
                                }
                            }
                        }
                    }
                },
                'type': {
                    type: 'select',
                    id: 'vehicleType',
                    title: 'Vehicle Type',
                    dataStoreId: 'types',
                    value: data.stock.type ? data.stock.type.id : '',
                    onChange: function (data) {

                        $('#vehicleTypeManual').val('');
                        if (-1 == $('#vehicleType').val()) {
                            $('#' + _w.valuationview.ti.tid + '_type').hide();
                            $('#' + _w.valuationview.ti.tid + '_typeManual').show();
                        }
                        else {
                            $('#' + _w.valuationview.ti.tid + '_typeManual').hide();
                            $('#' + _w.valuationview.ti.tid + '_type').show();


                            if (_w.valuationview.firstTimeCheck != true) {
                                if (_w.valuationview.newItem) {
                                    _w.valuationview._updatePrice(null, false);
                                }
                                else {
                                    _w.valuationview._updatePrice();
                                }
                            }
                            else {
                                _w.valuationview.firstTimeCheck = false;
                            }

                        }


                    }
                },
                'makeManual': {
                    type: 'input',
                    id: 'vehicleMakeManual',
                    title: 'Vehicle Make',
                    //dataStoreId : 'makes',
                    value: data.stock.type ? data.stock.type.model.make.id : '',
                },
                'modelManual': {
                    type: 'input',
                    id: 'vehicleModelManual',
                    title: 'Vehicle Model',
                    //dataStoreId : 'models',
                    value: data.stock.type ? data.stock.type.model.id : '',
                },
                'typeManual': {
                    type: 'input',
                    id: 'vehicleTypeManual',
                    title: 'Vehicle Type',
                    //dataStoreId : 'types',
                    value: data.stock.type ? data.stock.type.id : '',
                },
                'mmCode': {
                    type: 'input',
                    id: 'mmCode',
                    title: 'MM Code',
                    style: 'disable',
                    setAttrib: 'readonly',
                    value: data.stock.type ? data.stock.type.mmCode : ''
                },
                'fuelType': {
                    type: 'select',
                    id: 'vehicleFuelType',
                    title: 'Fuel Type',
                    dataStoreId: 'fuelTypes',
                    value: data.stock.fuelType ? data.stock.fuelType : ''
                },
                'transmissionType': {
                    type: 'select',
                    id: 'vehicleTransmissionType',
                    title: 'Transmission Type',
                    dataStoreId: 'transmissionTypes',
                    value: data.stock.transmissionType ? data.stock.transmissionType : ''
                },
                'registrationNumber': {
                    type: 'input',
                    id: 'registrationNumber',
                    title: 'Registration no',
                    value: data.stock.registrationNumber ? data.stock.registrationNumber : '',
                    style: 'capitalise'
                },
                'vinNumber': {
                    type: 'input',
                    id: 'vinNumber',
                    title: 'Vin no',
                    value: data.stock.vinNumber ? data.stock.vinNumber : '',
                    style: 'capitalise'
                },
                'engineNumber': {
                    type: 'input',
                    id: 'engineNumber',
                    title: 'Eng. no',
                    value: data.stock.engineNumber ? data.stock.engineNumber : '',
                    style: 'capitalise'
                },
                'sighted': {
                    type: 'select',
                    id: 'sighted',
                    title: 'Sighted',
                    dataStoreId: 'yesno',
                    value: undefined != data.sighted && null != data.sighted
                        ? (data.sighted == true ? "1" : "0")
                        : "0"
                },
                'licenseDiscExpired': {
                    type: 'select',
                    id: 'licenseDiscExpired',
                    title: 'License Disc Expired',
                    dataStoreId: 'yesno',
                    value: undefined != data.licenseDiscExpired && null != data.licenseDiscExpired
                        ? (data.licenseDiscExpired == true ? "1" : "0")
                        : "0"
                },
                'km': {
                    type: 'input',
                    id: 'km',
                    title: 'Kms',
                    value: data.stock.km ? data.stock.km : ''
                },
                'condition': {
                    type: 'select',
                    id: 'vehicleCondition',
                    title: 'Condition',
                    dataStoreId: 'conditions',
                    value: data.stock.condition ? data.stock.condition : ''
                },
                'exteriorColour': {
                    type: 'select',
                    id: 'exteriorColour',
                    title: 'Main ext. colour',
                    dataStoreId: 'exteriorColours',
                    value: data.stock.exteriorColour ? data.stock.exteriorColour : ''
                },
                'interiorColour': {
                    type: 'select',
                    id: 'interiorColour',
                    title: 'Main int. colour',
                    dataStoreId: 'interiorColours',
                    value: data.stock.interiorColour ? data.stock.interiorColour : ''
                },
                'upholstery': {
                    type: 'select',
                    id: 'vehicleUpholstery',
                    title: 'Upholstery',
                    dataStoreId: 'upholsteries',
                    value: data.stock.upholstery ? data.stock.upholstery : ''
                },
                'papers': {
                    type: 'select',
                    id: 'vehiclePapers',
                    title: 'Papers',
                    dataStoreId: 'papers',
                    value: data.stock.papers ? data.stock.papers : ''
                },
                'natis': {
                    type: 'select',
                    id: 'vehicleNatis',
                    title: 'Natis',
                    dataStoreId: 'natis',
                    value: data.stock.natis ? data.stock.natis : ''
                },
                'spareKeys': {
                    type: 'select',
                    id: 'spareKeys',
                    title: 'Spare keys',
                    dataStoreId: 'sparekeys',
                    value: undefined != data.stock.spareKeys && null != data.stock.spareKeys
                        ? (data.stock.spareKeys == true ? "1" : "0")
                        : null
                },
                'fullServiceHistory': {
                    type: 'select',
                    id: 'fullServiceHistory',
                    title: 'Full service history',
                    dataStoreId: 'fsh',
                    value: data.stock.fullServiceHistory ? data.stock.fullServiceHistory : ''
                },
                'fshNotes': {
                    type: 'textarea-small',
                    id: 'fshNotes',
                    title: 'FSH notes',
                    value: data.stock.fshNotes ? data.stock.fshNotes : ''
                },
                'damages': {
                    type: 'damageDetails',
                    disabled: !App.permissions.valuationUpdateDamages,
                    id: 'damages',
                    dataStoreId: 'damages',
                    data: data.stock.damages ? data.stock.damages : {}
                },
                'damageTotal': 'R 0.00',
                'damageNotes': {
                    type: 'textarea-styled',
                    disabled: !App.permissions.valuationUpdateDamages,
                    id: 'damageNotes',
                    title: 'Damages comments',
                    style: 'damages-comments',
                    value: data.stock.damageNotes ? data.stock.damageNotes : ''
                },
                'previousRepairsNoted': {
                    type: 'checkbox',
                    id: 'previousRepairsNoted',
                    title: 'Previous repairs',
                    style: 'damages-comments',
                    value: data.stock.previousRepairsNoted ? data.stock.previousRepairsNoted : false
                },
                'previousRepairsNotes': {
                    type: 'textarea-styled',
                    disabled: !App.permissions.valuationUpdateDamages,
                    id: 'previousRepairsNotes',
                    title: 'Previous repairs notes',
                    style: 'damages-comments',
                    value: data.stock.previousRepairsNotes ? data.stock.previousRepairsNotes : '',
                    onChange: function () {
                        var haveData = ('' != $(this).val() ? true : false);
                        $('#previousRepairsNoted').prop('checked', haveData);
                    }
                },
                'coverReceived': {
                    type: 'textarea-styled',
                    disabled: !App.permissions.valuationUpdateCoverReceived,
                    id: 'coverReceived',
                    title: 'Cover Received',
                    style: 'cover-received',
                    value: data.stock.coverReceived ? data.stock.coverReceived : ''
                },
                'accessories': {
                    type: 'checkGroup',
                    id: 'accessories',
                    dataStoreId: 'accessories',
                    itemName: 'accessory',
                    data: data.stock.accessories ? data.stock.accessories : {}
                },
                'accessoryNotes': {
                    type: 'textarea-styled',
                    id: 'accessoryNotes',
                    title: 'Comments',
                    style: 'comment mobile-comment',
                    areaStyle: 'comment-text-box',
                    value: data.stock.accessoryNotes ? data.stock.accessoryNotes : ''
                },
                'mainImage': {
                    type: 'image',
                    id: 'mainImage',
                    baseImage: 'main_img_car.jpg',
                    view: !App.permissions.valuationUploadPhotos,
                    value: data.stock.mainImage ? data.stock.mainImage : ''
                },
                'frontImage': {
                    type: 'image',
                    id: 'frontImage',
                    baseImage: 'front_car.jpg',
                    view: !App.permissions.valuationUploadPhotos,
                    value: data.stock.frontImage ? data.stock.frontImage : ''
                },
                'leftImage': {
                    type: 'image',
                    id: 'leftImage',
                    baseImage: 'left_car.jpg',
                    view: !App.permissions.valuationUploadPhotos,
                    value: data.stock.leftImage ? data.stock.leftImage : ''
                },
                'rightImage': {
                    type: 'image',
                    id: 'rightImage',
                    baseImage: 'right_car.jpg',
                    view: !App.permissions.valuationUploadPhotos,
                    value: data.stock.rightImage ? data.stock.rightImage : ''
                },
                'backImage': {
                    type: 'image',
                    id: 'backImage',
                    baseImage: 'back_car.jpg',
                    view: !App.permissions.valuationUploadPhotos,
                    value: data.stock.backImage ? data.stock.backImage : ''
                },
                'interiorImage': {
                    type: 'image',
                    id: 'interiorImage',
                    baseImage: 'interior_car.jpg',
                    view: !App.permissions.valuationUploadPhotos,
                    value: data.stock.interiorImage ? data.stock.interiorImage : ''
                },
                'engineImage': {
                    type: 'image',
                    id: 'engineImage',
                    baseImage: 'engine_car.jpg',
                    view: !App.permissions.valuationUploadPhotos,
                    value: data.stock.engineImage ? data.stock.engineImage : ''
                },
                'natisImage': {
                    type: 'image',
                    id: 'natisImage',
                    baseImage: 'copy_of_natis_car.jpg',
                    view: !App.permissions.valuationUploadPhotos,
                    value: data.stock.natisImage ? data.stock.natisImage : ''
                },
                'clubs': {
                    type: 'select',
                    id: 'clubs',
                    title: 'Select clubs',
                    dataStoreId: 'clubs',
                    multiple: true,
                    value: ''
                },
                'print': {
                    constructor: 'Button',
                    items: ('New Valuation' == data.jobState
                    && 'Dealership Valuator' != App.permissions.name
                    && 'Dealership Sales' != App.permissions.name)
                        ? {
                        Export: {
                            preset: 'Print',
                            id: 'printValuationPdf',
                            handler: _w.valuationview.printValuationPdf
                        },
                        ExportTC: {
                            preset: 'PrintTC',
                            id: 'printValuationPdfTC',
                            handler: _w.valuationview.printValuationPdfTC
                        }
                    }
                        : {
                        Export: {
                            preset: 'Print',
                            id: 'printValuationPdf',
                            handler: _w.valuationview.printValuationPdf
                        }
                    }
                },
                'infCreated': data.created ? ((data.created).split(' '))[0] : '',
                'infValuationNumber': data.valuationNumber ? data.valuationNumber : '',
                'infReferenceNumber': data.stock.referenceNumber ? data.stock.referenceNumber : '',
                'infStatus': data.jobState ? data.jobState : '',
                'infCreatedBy': data.createdBy && data.createdBy.firstName
                    ? data.createdBy.firstName + ' ' + data.createdBy.familyName
                    : '',
                'infValuator': data.valuatedBy && data.valuatedBy.firstName
                    ? data.valuatedBy.firstName + ' ' + data.valuatedBy.familyName
                    : '',
                'infSalesUser': data.salesProfile && data.salesProfile.firstName
                    ? data.salesProfile.firstName + ' ' + data.salesProfile.familyName
                    : '',
                'infLoadedOnPriceGuide': data.stock.loadedOnPriceGuide
                    ? ((data.stock.loadedOnPriceGuide).split(' '))[0] : '',
                'infTradePrice': data.stock.tradePrice ? 'R ' + data.stock.tradePrice : '0.00',
                'infRetailPrice': data.stock.retailPrice ? 'R ' + data.stock.retailPrice : '0.00',
                'infListPrice': data.stock.listPrice ? 'R ' + data.stock.listPrice : '0.00',
                'firstName': {
                    type: 'input',
                    id: 'firstName',
                    title: 'Customer name',
                    value: data.firstName ? data.firstName : ''
                },
                'familyName': {
                    type: 'input',
                    id: 'familyName',
                    title: 'Customer surname',
                    value: data.familyName ? data.familyName : ''
                },
                'idNumber': {
                    type: 'input',
                    id: 'idNumber',
                    title: 'ID',
                    value: data.idNumber ? data.idNumber : ''
                },
                'mobile': {
                    type: 'mobile',
                    id: 'mobile',
                    title: 'Mobile',
                    value: data.mobile ? data.mobile : ''
                },
                'email': {
                    type: 'input',
                    id: 'email',
                    title: 'Email',
                    value: data.email ? data.email : ''
                },
                'department': {
                    type: 'select',
                    id: 'department',
                    title: 'Department',
                    dataStoreId: 'departments',
                    value: data.department ? data.department : ''
                },
                'region': {
                    type: 'select',
                    id: 'region',
                    title: 'Region',
                    dataStoreId: 'regions',
                    value: data.region && data.region.id ? data.region.id : '',
                    onChange: function () {
                        if (!App.DataStore.getItem('BuildSelect:region', false)) {
                            App.DataStore.loadSelectListData(
                                'cities', false, 'Location', 'Town.SelectList', null,
                                {
                                    "Filter": {
                                        "region": $(this).val()
                                    }
                                }
                            );
                        }
                    }
                },
                /*'city' : {
                 type        : 'select',
                 id          : 'city',
                 title       : 'Town',
                 dataStoreId : 'cities',
                 value       : data.city && data.city.id ? data.city.id : '',
                 options 	: {
                 minimumInputLength: 3
                 }
                 },*/
                /*'street' : {
                 type  : 'input',
                 id    : 'street',
                 title : 'Street',
                 value : data.street ? data.street : '',
                 maxlength : 75
                 },*/
                'requiredPrice': {
                    type: 'input',
                    style: 'rand-input',
                    id: 'requiredPrice',
                    title: 'Required price',
                    value: data.requiredPrice ? data.requiredPrice : ''
                },
                'amountOffered': {
                    type: 'input',
                    disabled: true,
                    style: 'rand-input',
                    id: 'amountOffered',
                    title: newtitle,
                    value: data.amountOffered ? data.amountOffered : ''
                },
                'bankSettlement': {
                    type: 'input',
                    disabled: false,
                    style: 'rand-input',
                    id: 'bankSettlement',
                    title: 'Bank Settlement',
                    value: data.bankSettlement ? data.bankSettlement : ''
                },
                'overAllowance': {
                    type: 'input',
                    style: 'rand-input',
                    id: 'overAllowance',
                    title: 'O.A',
                    value: data.overAllowance ? data.overAllowance : '',
                    onChange: function () {

                        //var totalOfferVal = (parseInt(document.getElementById('amountOffered').value)).toFixed(2) + (parseInt(document.getElementById('overAllowance').value)).toFixed(2);

                        if (isNaN(parseInt(document.getElementById('overAllowance').value))) {

                            //var totalOfferVal = (parseInt(document.getElementById('amountOffered').value)).toFixed(2) + val((0.00).toFixed(2));
                            $('#standInValue').val((parseInt(document.getElementById('amountOffered').value)).toFixed(2));
                        }
                        else {
                            $('#standInValue').val((Number((parseInt(document.getElementById('amountOffered').value))) + Number((parseInt(document.getElementById('overAllowance').value)))).toFixed(2)); //andreb // need to change the value on change -> do sum -> populate previousRepairsNoted
                        }
                    }

                },
                'standInValue': {
                    type: 'input',
                    disabled: true,
                    style: 'rand-input',
                    id: 'standInValue',
                    title: 'Total offer',
                    value: (parseInt(data.overAllowance) + parseInt(data.amountOffered)).toFixed(2)
                        ? (parseInt(data.overAllowance) + parseInt(data.amountOffered)).toFixed(2) : ''

                },
                'projectedRetail': {
                    type: 'input',
                    style: 'rand-input',
                    id: 'projectedRetail',
                    title: 'Projected retail',
                    value: data.projectedRetail ? data.projectedRetail : ''
                },
                'plannedMargin': {
                    type: 'input',
                    style: 'rand-input',
                    id: 'plannedMargin',
                    title: 'Planned margin',
                    value: data.plannedMargin ? data.plannedMargin : ''
                },
                'valuators': {
                    type: 'select',
                    id: 'valuators',
                    title: 'Select valuator',
                    dataStoreId: 'valuators',
                    multiple: true,
                    value: data.valuators ? data.valuators : []
                },
                'salesProfile': {
                    type: 'select',
                    id: 'salesProfile',
                    title: 'Sales person',
                    dataStoreId: 'sales',
                    value: ''
                },
                'salesAmountOffered': {
                    type: 'input',
                    style: 'rand-inputs',
                    id: 'salesAmountOffered',
                    title: 'Amount',
                    value: data.amountOffered ? data.amountOffered : '0.00',
                    onFocus: function () {
                        var $_this = $(this),
                            value = $_this.val();

                        if (value == '0.00') {
                            $_this.val('');
                        }
                    },
                    onBlur: function () {
                        var $_this = $(this),
                            value = $_this.val();

                        if (value === '') {
                            $_this.val('0.00');
                        }
                    }
                },
                'salesComments': {
                    type: 'textarea-styled',
                    id: 'salesComments',
                    title: 'Comments',
                    style: 'comment',
                    areaStyle: 'comment-text-box',
                    value: data.salesComments ? data.salesComments : ''
                },

                'customerAmountOffered': {
                    type: 'input',
                    style: 'rand-inputs',
                    id: 'customerAmountOffered',
                    title: 'Amount',
                    value: data.amountOffered ? data.amountOffered : '0.00',
                    onFocus: function () {
                        var $_this = $(this),
                            value = $_this.val();

                        if (value == '0.00') {
                            $_this.val('');
                        }
                    },
                    onBlur: function () {
                        var $_this = $(this),
                            value = $_this.val();

                        if (value === '') {
                            $_this.val('0.00');
                        }
                    }
                },
                'customerComments': {
                    type: 'textarea-styled',
                    id: 'customerComments',
                    title: 'Comments',
                    style: 'comment',
                    areaStyle: 'comment-text-box',
                    value: data.salesComments ? data.salesComments : ''
                },

                'stockNumber': {
                    type: 'input',
                    id: 'stockNumber',
                    title: 'Stock number',
                    value: data.stock.stockNumber ? data.stock.stockNumber : ''
                },
                'stockNumberDD': {
                    type: 'input',
                    id: 'stockNumberDD',
                    title: 'Stock number',
                    value: data.stock.stockNumber ? data.stock.stockNumber : ''
                },
                'dealNotDoneSelection': {
                    type: 'select',
                    id: 'dealNotDoneSelection',
                    title: 'Reason',
                    dataStoreId: 'dealNotDoneSelections',
                    value: data.dealNotDoneSelection ? data.dealNotDoneSelection : ''
                },

                'dealNotDoneReason': {
                    type: 'textarea-styled',
                    id: 'dealNotDoneReason',
                    title: 'Description',
                    style: 'comment',
                    areaStyle: 'comment-text-box',
                    value: data.dealNotDoneReason ? data.dealNotDoneReason : ''
                }
            };
		},
		printValuationPdf: function ()
		{
			var task = 'Pdf.Print003';
			if ('New Valuation' == _w.valuationview.itemData.jobState
							&& ('Dealership Valuator' == App.permissions.name
											|| 'Dealership Sales' == App.permissions.name))
			{
				// T&C version
				task = 'Pdf.Print001';
			}
			else if ('Dealership Valuator' == App.permissions.name
							|| 'Dealership Sales' == App.permissions.name)
			{
				task = 'Pdf.Print002';
			}
			App.API.getTask(
							'printValuation:' + _w.valuationview.itemData.stock.id,
							'Valuation', task, _w.valuationview.itemId,
							{}, function () {
				App.API.execTask(
								'printValuation:' + _w.valuationview.itemData.stock.id, {}, {},
								_w.valuationview._onExportReceived, _w.taskExecError,
								'EXPORT', true
								);
			}, _w.taskContractError
							);
		},
		printValuationPdfTC: function ()
		{
			// Consider the T&C requirement.
			var task = 'Pdf.Print001';
			App.API.getTask(
							'printValuation:' + _w.valuationview.itemData.stock.id,
							'Valuation', task, _w.valuationview.itemId,
							{}, function () {
				App.API.execTask(
								'printValuation:' + _w.valuationview.itemData.stock.id, {}, {},
								_w.valuationview._onExportReceived, _w.taskExecError,
								'EXPORT', true
								);
			}, _w.taskContractError
							);
		},
		_listMakesModelsTypes: function (fromItemData, callback)
		{
			if (fromItemData)
			{
				var year = _w.valuationview.itemData.stock.vehicleYear;
				var category = _w.valuationview.itemData.stock.type.category.id;
				var make = _w.valuationview.itemData.stock.type.model.make.id;
				var model = _w.valuationview.itemData.stock.type.model.id;
				var type = _w.valuationview.itemData.stock.type.id;
				var mmcode = _w.valuationview.itemData.stock.type.mmcode;
			}
			else
			{
				var year = $('#vehicleYear').val();
				var category = $('#vehicleCategory').val();
				var make = $('#vehicleMake').val();
				var model = $('#vehicleModel').val();
				var type = $('#vehicleType').val();
				var mmcode = $('#mmCode').val();
			}
			if (year && category)
			{
				App.DataStore.loadSelectListData(
								'makes', false, 'Stock', 'Utility.ListMakes', null,
								{"Filter": {
										"category": category,
										"year": year
									}}, {}, $.proxy(function (categoryId)
				{
					if (8 == categoryId)
					{
						var data = App.DataStore.getData('makes');
						data.unshift({
							value: -1,
							label: 'Custom'
						});
						App.DataStore.setData('makes', data);
					}
				}, this, category)
								);
			}
			if (make && year && category)
			{
				App.DataStore.loadSelectListData(
								'models', false, 'Stock', 'Utility.ListModels', null,
								{"Filter": {
										"make": make,
										"category": category,
										"year": year
									}}, {}, $.proxy(function (categoryId)
				{
					if (8 == categoryId)
					{
						var data = App.DataStore.getData('models');
						data.unshift({
							value: -1,
							label: 'Custom'
						});
						App.DataStore.setData('models', data);
					}
				}, this, category)
								);
			}
			if (model && year && category)
			{
				App.DataStore.loadSelectListData(
								'types', false, 'Stock', 'Utility.ListTypes', null,
								{"Filter": {
										"model": model,
										"category": category,
										"year": year
									}}, {}, $.proxy(function (categoryId, callback)
				{
					if (8 == categoryId)
					{
						var data = App.DataStore.getData('types');
						data.unshift({
							value: -1,
							label: 'Custom'
						});
						App.DataStore.setData('types', data);
					}
					if (callback)
					{
						callback();
					}
				}, this, category, callback)
								);
			}
		},
		_onDataAndTemplate: function ()
		{
			App.DataStore.loadSelectListData(
							'tuhpi', false, 'Stock', 'Tuhpi.List', null, {
								"Filter":
												{
													"stock": _w.valuationview.itemData.stock.id,
													"company": App.companyData.id

												}
							}, {}, function ()
			{
				// data is retrieved
				var tuHpiData = App.DataStore.getData('tuhpi');

                _w.valuationview._loadHpiReportData(tuHpiData);


			});

			var total = 0.00;



			if (null == App.API.taskContract('gridStockHistory'))
			{
				App.API.getTask(
								'gridStockHistory', 'Stock', 'PricingHistory.Grid', null,
								{}, _w.valuationview.loadHistoricalGrid, _w.taskContractError
								);
			}
			else
			{
				_w.valuationview.loadHistoricalGrid(null, {}, {});
			}

			$.each($.find('.damage-input'), function (i, input) {
				total += parseFloat($(input).val());
			});
			$('#' + _w.valuationview.ti.tid + '_damageTotal').html('R ' + total);
			$('#doAcceptOffer').prop('disabled', true);
			$('#doRemoveAccept').prop('disabled', true);

			
			$('#doRemoveAcceptSlider').click(function () {
					$('#dropStock').insertAfter( '#btnKeepForStock'); //moved the div to reuse the code
					$('#dropStock').slideDown();
					$('#doSendToStock').hide();
					$('#stockNumber').prop('disabled', false);
					$('#stockNumberDD').prop('disabled', false);
					$('#doRemoveAcceptSlider').prop('disabled', true);
					$('#doRemoveAccept').prop('disabled', false);
					$('#doRemoveAccept').show();
					$('#btnFetchTu').prop('disabled', true);
				});

			$('#doRemoveAccept').click(function () {
				
				var stockNo = $('#stockNumber').val();
				if (null == stockNo || '' == stockNo)
				{
					//show the stock number field
					
					alert('Please enter a stock number.');
					return;
				}
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				if (!$('#acceptStockHPIdisclaimer').is(':checked'))
				{
					alert('Please accept the conditions before sending.');
					return;
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnRemoveAccept').prop('disabled', true);
				$('#btnRemove').prop('disabled', true);
				$('#btnAcceptOffer').prop('disabled', true);
				$('#btnKeepForStock').prop('disabled', true);
			
				var data = _w.valuationview._prepValuationUpdateData();
				
				/*var data = _w.valuationview._prepValuationUpdateData();
					App.API.getTask(
										'createValuationStock', 'Valuation', 'Valuation.UpdateStock',
										null, {}, $.proxy(function (data) {
							App.API.execTask(
											'createValuationStock', data, {},
											_w.valuationview._onValuationUpdated, _w.taskExecError
											);
						}, this, data), _w.taskContractError
										);*/
					//Move valuation to stock, to try out the 2nd function in order to not Repeat Oneself
//					var data = _w.valuationview._prepValuationUpdateData();
										/*	App.API.execTask(
								'updateValuation:' + _w.valuationview.itemId, data, {},
								function () {
									App.API.directRoute(
													'keepForStockOnValuation:' + _w.valuationview.itemId,
													'Valuation', 'Valuation.MoveToKeepForStock', _w.valuationview.itemId, {},
													_w.valuationview._onValuationUpdated, _w.taskExecError
													);
								}, _w.taskExecError
								);*/

				App.API.getTask(
								'PriceGuideRemove' + _w.valuationview.itemData.stock.priceGuide, 'PriceGuide', 'PriceGuide.Remove',
								_w.valuationview.itemData.stock.priceGuide,
								{}, function () {
					App.API.execTask(
									'PriceGuideRemove' + _w.valuationview.itemData.stock.priceGuide, data, {},
									function () {
										App.API.directRoute(
														'offerAcceptedOnValuation:' + _w.valuationview.itemId,
														'Valuation', 'Valuation.MoveToOfferAccepted', _w.valuationview.itemId, {},
														_w.valuationview._onValuationUpdated, _w.taskExecError
														);
									}, _w.taskExecError
									);
				}, _w.taskContractError
								);
				
				
				//send to stock
				App.API.getRoute(
						'sendToStock:' + _w.valuationview.itemId, 'Valuation', 'Valuation.SendToStock', _w.valuationview.itemId,
						{}, function () {
						var data = _w.valuationview._prepValuationUpdateData();
						App.API.execRoute(
										'sendToStock:' + _w.valuationview.itemId, data, {},
										_w.valuationview._onValuationUpdated, _w.taskExecError
										);
					}, _w.taskContractError
				);
				
				
				
			});



			$('#btnRemove').click(function () {
				if (!$('#frmValuationView').valid())
				{
					return;
				}
				$('#btnUpdate').prop('disabled', true);
				$('#btnRemoveAccept').prop('disabled', true);
				$('#btnRemove').prop('disabled', true);
				$('#btnAcceptOffer').prop('disabled', true);
				$('#btnKeepForStock').prop('disabled', true);
				var data = _w.valuationview._prepValuationUpdateData();
				App.API.getTask(
								'PriceGuideRemove' + _w.valuationview.itemData.stock.priceGuide, 'PriceGuide', 'PriceGuide.Remove',
								_w.valuationview.itemData.stock.priceGuide,
								{}, function () {
					App.API.execTask(
									'PriceGuideRemove' + _w.valuationview.itemData.stock.priceGuide, data, {},
									function () {
										App.API.directRoute(
														'keepForStockOnValuation:' + _w.valuationview.itemId,
														'Valuation', 'Valuation.MoveToKeepForStock', _w.valuationview.itemId, {},
														_w.valuationview._onValuationUpdated, _w.taskExecError
														);
									}, _w.taskExecError
									);
				}, _w.taskContractError
								);
			});

			if (_w.valuationview.itemData
							&& _w.valuationview.itemData.region
							&& _w.valuationview.itemData.region.id)
			{
				App.DataStore.loadSelectListData(
								'cities', false, 'Location', 'Town.SelectList', null,
								{"Filter": {
										"region": _w.valuationview.itemData.region.id
									}}
				);
			}
			if (null != _w.valuationview.itemData.stock.priceGuide
							&& 0 < _w.valuationview.itemData.stock.highestOffer)
			{
				_w.valuationview.priceGuideId = _w.valuationview.itemData.stock.priceGuide;
				App.API.getTask(
								'offerList', 'PriceGuide', 'Offer.List',
								_w.valuationview.itemData.stock.priceGuide, {}, function () {
					App.API.execTask(
									'offerList', {}, {},
									function (response)
									{
										var offers = response.Data;
										if (offers.length)
										{
											var highest = 0;
											var lowestDate = 0;
											var highestId = 0;
											var valid = 0;
											for (var x in offers)
											{
												if ('Valid Offer' != offers[x].status
																&& 'Updateable Offer' != offers[x].status)
												{
													continue;
												}
												valid++;
												var dateInt = parseInt(
																offers[x].created.split(' ')[0].split('-').join('')
																+ offers[x].created.split(' ')[1].split(':').join('')
																);
												if ((parseInt(offers[x].amount) == highest && dateInt < lowestDate)
																|| parseInt(offers[x].amount) > highest)
												{
													highest = parseInt(offers[x].amount);
													highestId = x;
													lowestDate = dateInt;
												}
											}
											if (0 == valid)
											{
												var modalbody = '<div style="font-weight:bold;color:#9B2022;">There are no valid offers!</div>';
												$('#dealDoneOfferList').html(modalbody);
												$('#doAcceptOffer').prop('disabled', true);
												$('#doRemoveAccept').prop('disabled', true);
												return;
											}
											_w.valuationview.highestOfferId = highestId;
											var modalbody = '<table class="table table-bordered table-condensed table-striped">';
											modalbody += '<tr class="table-header-red"><td>Company</td><td>Date Offered</td><td>Amount</td></tr>';
											for (var x in offers)
											{
												if ('Valid Offer' != offers[x].status
																&& 'Updateable Offer' != offers[x].status)
												{
													continue;
												}
												var isOwn = highestId == x
																? true
																: false;
												modalbody +=
																'<tr class="modalrow ' + (isOwn ? 'red' : 'black') + '">'
																+ '<td class="date">' + offers[x].company.name + '</td>'
																+ '<td class="date">' + offers[x].created.split(' ')[0] + '</td>'
																+ '<td class="wide">R' + offers[x].amount.split('.')[0] + '</td>'
																+ '</tr>';
											}
											modalbody += '</table>';
											$('#doAcceptOffer').prop('disabled', false);
											$('#doRemoveAccept').prop('disabled', false);
										}
										else
										{
											var modalbody = '<div style="font-weight:bold;color:#9B2022;">There are no valid offers!</div>';
										}
										$('#dealDoneOfferList').html(modalbody);
									}, _w.taskExecError
									);
				}, _w.taskContractError
								);
			}

			$('#HPIhide').show();
			if (_w.valuationview.limited)
			{
				$('input').prop('disabled', true);
				$('button').prop('disabled', true);
				$('checkbox').prop('disabled', true);
				$('textarea').prop('disabled', true);

				$('#downloadTuhpi').prop('disabled', false);
				$('#overAllowance').prop('disabled', false);
				$('#standInValue').prop('disabled', true);
				$('#btnUnarchive').prop('disabled', false);
				$('#printValuationPdf').prop('disabled', false);
				$('#optSendToSales').prop('disabled', false);
				$('#salesProfile').prop('disabled', false);
				$('button[data-id="salesProfile"]').prop('disabled', false);
				$('#salesAmountOffered').prop('disabled', false);
				$('#salesComments').prop('disabled', false);
				$('#btnSendToSales').prop('disabled', false);
				$('#printValuationPdf').prop('disabled', false);
				$('#btnSendToPg').prop('disabled', false);
				$('#acceptStockHPIdisclaimer').prop('disabled', false);
				$('#acceptStockDDHPIdisclaimer').prop('disabled', false);
				$('button[data-id="clubs"]').prop('disabled', false);

                $('#optSendToCustomer').prop('disabled', false);
                $('#customerAmountOffered').prop('disabled', false);
                $('#customerComments').prop('disabled', false);

				// Mobi buttons
				$('#mobiAuctionBtn').prop('disabled', false);
				$('#mobiPriceGuideBtn').prop('disabled', false);
				$('#mobiValuationsBtn').prop('disabled', false);
			}
			if (App.permissions.settingsHpiReport == false)
			{
				$('#requestHPIreport').hide();
                $('#requestHPIAccidentReport').hide();
			}

			$('#sectionSelectValuator').hide();
			if (!_w.valuationview.newItem)
			{
				if (App.permissions.settingsHpiReport
								&& 'New Valuation' != _w.valuationview.itemData.jobState)
				{
					$('#requestHPIreport').show();
                    $('#requestHPIAccidentReport').show();
				}
				$('#retailPrice').val(_w.valuationview.itemData.stock.retailPrice);
				$('#tradePrice').val(_w.valuationview.itemData.stock.tradePrice);
                $('#listPrice').val(_w.valuationview.itemData.stock.listPrice);

                //console.log('_w.valuationview.itemData',_w.valuationview.itemData);

				switch (_w.valuationview.itemData.jobState)
				{
					case 'New Valuation':

                        //console.log('_w.valuationview.itemData.isPublicCustomer',_w.valuationview.itemData.isPublicCustomer);

                        if(_w.valuationview.itemData.isPublicCustomer)
                        {
                            $('#optSendToCustomer').show();
                        }
						$('#btnSaveAsSales').show();
						$('#btnSaveAsPending').show();
						$('#optSendToPg').show();
						$('#btnSendToStock').show();
						$('#btnArchive').show();
						true == App.permissions.valuationCreateSales
										? $('#sectionSelectValuator').show()
										: $('#sectionSelectValuator').hide();
						if (!App.permissions.valuationUpdateDamages)
						{
							$('.damages-form').hide();
						}
						else
						{
							$('.damages-form').show();
						}
						if (!App.permissions.valuationUploadPhotos)
						{
							$('.photos-form').html('&nbsp;');
						}
						break;
					case 'Pending Valuation':
                        if(_w.valuationview.itemData.isPublicCustomer)
                        {
                            $('#optSendToCustomer').show();
                        }
						$('#optSendToSales').show();
						$('#optSendToPg').show();
						$('#btnSendToStock').show();
						$('#btnArchive').show();

						if (null != _w.valuationview.itemData.stock.priceGuide
										&& 0 < _w.valuationview.itemData.stock.highestOffer)
						{
							$('#btnAcceptOffer').show();
							$('#doAcceptOffer').show();
							$('#btnKeepForStock').show();
							$('#btnSendToDealNotDone').show();
							$('#doSendToDealNotDone').show();
						}
						else
						{
							$('#btnSendToDealDone').show();
							$('#doSendToDealDone').show();
							$('#doSendToDealNotDone').show();
						}
						if (!App.permissions.valuationUpdateDamages)
						{
							$('.damages-form').hide();
						}
						else
						{
							$('.damages-form').show();
						}
						if (!App.permissions.valuationUploadPhotos)
						{
							$('.photos-form').html('&nbsp;');
						}
						break;
					case 'Complete Valuation':

						$('#optSendToSales').show();
						$('#optSendToPg').show();
						$('#btnSendToStock').show();
						$('#btnArchive').show();
						if (null != _w.valuationview.itemData.stock.priceGuide
										&& 0 < _w.valuationview.itemData.stock.highestOffer)
						{



							if (_w.valuationview.itemData.previousState == 'Offer Accepted')
							{
								//console.log("previousState", _w.valuationview.itemData);
								$('#btnAcceptOffer').hide;
							}
							else {
								$('#btnAcceptOffer').show();
							}


							$('#doAcceptOffer').show();
							$('#btnKeepForStock').show();
							$('#btnSendToDealNotDone').show();
						}
						else
						{
							$('#btnSendToDealDone').show();
							$('#doSendToDealDone').show();
							$('#doSendToDealNotDone').show();
						}
						break;
					case 'Offer Accepted':
						$('#optSendToPg').show();
						$('#optSendToSales').show();
						$('#btnSendToStock').show();
						$('#btnSendToStock').prop('disabled', false);
						$('#btnKeepForStock').hide();
						$('#stockNumber').prop('disabled', false);
						$('#doSendToStock').prop('disabled', false);
						$('#btnArchive').show();
						$('#btnArchive').prop('disabled', false);
						break;
					case 'Deal Done':

						$('#btnSendToStock').show();
						$('#btnSendToStock').prop('disabled', false);
						$('#stockNumber').prop('disabled', false);
						$('#doSendToStock').prop('disabled', false);
						$('#doRemoveAcceptSlider').prop('disabled', false);
						$('#btnArchive').show();
						$('#btnArchive').prop('disabled', false);
						break;
					case 'Deal Not Done':
						$('#btnArchive').show();
						break;
					case 'Archived':
						$('#btnUnarchive').show();
						break;
					case 'Price Guide':
					$('#doRemoveAcceptSlider').prop('disabled', false);
						$('#optSendToSales').show();
						$('#btnSendToDealNotDone').show();
						if (null != _w.valuationview.itemData.stock.priceGuide
										&& 0 < _w.valuationview.itemData.stock.highestOffer)
						{
							$('#btnRemoveAccept').show();
							$('#doRemoveAccept').show();
							$('#btnRemove').show();
						}
						break;
				}
			}
			else
			{
				$('#requestHPIreport').hide();
                $('#requestHPIAccidentReport').hide();
			}

			/*
			 * Permissions
			 */
			$('#optSendToPg').prop('disabled', true == App.permissions.valuationRoutePriceguide ? false : true);
			$('#optSendToSales').prop('disabled', true == App.permissions.valuationRouteComplete ? false : true);
			$('#btnUpdate').prop('disabled', true == App.permissions.valuationUpdate ? false : true);
			$('#btnSendToStock').prop('disabled', true == App.permissions.valuationRouteStock ? false : true);
			$('#btnSaveAsPending').prop('disabled', true == App.permissions.valuationRoutePending ? false : true);
			$('#btnAcceptOffer').prop('disabled', true == App.permissions.valuationRouteDealDone ? false : true);
			$('#doSendToDealNotDone').prop('disabled', true == App.permissions.valuationRouteDealDone ? false : true);
			$('#doSendToDealDone').prop('disabled', true == App.permissions.valuationRouteDealDone ? false : true);
			$('#btnRemoveAccept').prop('disabled', true == App.permissions.valuationRouteDealDone ? false : true);
			$('#btnKeepForStock').prop('disabled', true == App.permissions.valuationRouteDealNotDone ? false : true);
			$('#btnSendToDealNotDone').prop('disabled', true == App.permissions.valuationRouteDealNotDone ? false : true);
			$('#btnRemove').prop('disabled', true == App.permissions.valuationRouteDealNotDone ? false : true);
			$('#btnExpire').prop('disabled', true == App.permissions.valuationRouteDealNotDone ? false : true);
			if ('Dealership Sales' == App.permissions.name && !_w.valuationview.newItem)
			{
				$('#btnSaveAsPending').hide();
			}

			$('#btnArchive').prop('disabled', true == App.permissions.valuationArchive ? false : true);
			$('#printValuationPdf').prop('disabled', true == App.permissions.valuationPrint ? false : true);
			$('#btnB4cAccidentReport').prop('disabled', true == App.permissions.valuationB4cReport ? false : true);
			$('#btnBwmAccidentReport').prop('disabled', true == App.permissions.valuationBmw ? false : true);



			true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid + '_overAllowance').show() : $('#' + _w.valuationview.ti.tid + '_overAllowance').hide();
			true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid + '_standInValue').show() : $('#' + _w.valuationview.ti.tid + '_standInValue').hide();
			true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid + '_projectedRetail').show() : $('#' + _w.valuationview.ti.tid + '_projectedRetail').hide();
			true == App.permissions.valuationPricingDetails ? $('#' + _w.valuationview.ti.tid + '_plannedMargin').show() : $('#' + _w.valuationview.ti.tid + '_plannedMargin').hide();


			_w.valuationview._setupValidation();
		},
		_onValuationViewDataReceived: function (response)
		{
			_w.valuationview.itemId = response.Data.id;
			_w.valuationview.itemData = response.Data;
			_w.valuationview._listMakesModelsTypes(true);
			_w.valuationview.setValuationViewFormMeta(response.Data);
			_w.valuationview.ti.hydrate(_w.valuationview.formMeta);
			_w.valuationview.ti.onPublish(_w.valuationview._onDataAndTemplate);


            App.DataStore.loadSelectListData(
                'years', false, 'Stock', 'Year.SelectList', null,
                {}
            );
            App.DataStore.loadSelectListData(
                'categories', false, 'Stock', 'Category.SelectList', null,
                {}
            );

            App.DataStore.loadSelectListData(
                'fuelTypes', false, 'Stock', 'FuelType.SelectList', null,
                {}
            );
            App.DataStore.loadSelectListData(
                'transmissionTypes', false, 'Stock', 'TransmissionType.SelectList', null,
                {}
            );
            App.DataStore.loadSelectListData(
                'damages', false, 'Stock', 'Damage.SelectList', null,
                {}
            );
            App.DataStore.loadSelectListData(
                'accessories', false, 'Stock', 'Accessory.SelectList', null,
                {}
            );

			App.DataStore.loadSelectListGroup([
				{dataId: 'conditions', isStatic: true, workspace: 'Stock', task: 'Condition.SelectList'},
				{dataId: 'exteriorColours', isStatic: true, workspace: 'Stock', task: 'ExteriorColour.SelectList'},
				{dataId: 'interiorColours', isStatic: true, workspace: 'Stock', task: 'InteriorColour.SelectList'},
				{dataId: 'upholsteries', isStatic: true, workspace: 'Stock', task: 'Upholstery.SelectList'},
				{dataId: 'papers', isStatic: true, workspace: 'Stock', task: 'Paper.SelectList'},
				{dataId: 'natis', isStatic: true, workspace: 'Stock', task: 'Natis.SelectList'},
				{dataId: 'fsh', isStatic: true, workspace: 'Stock', task: 'FullServiceHistory.SelectList'},
				//{dataId: 'fuelTypes', isStatic: true, workspace: 'Stock', task: 'FuelType.SelectList'},
				//{dataId: 'transmissionTypes', isStatic: true, workspace: 'Stock', task: 'TransmissionType.SelectList'},
				//{dataId: 'damages', isStatic: true, workspace: 'Stock', task: 'Damage.SelectList'},
				//{dataId: 'accessories', isStatic: true, workspace: 'Stock', task: 'Accessory.SelectList'},
				{dataId: 'clubs', isStatic: true, workspace: 'PriceGuide', task: 'Club.SelectList'},
				{dataId: 'valuators', isStatic: true, workspace: 'User', task: 'Profile.ValuatorList'},
				{dataId: 'sales', isStatic: true, workspace: 'User', task: 'Profile.SalesList'},
				{dataId: 'regions', isStatic: true, workspace: 'Location', task: 'Region.SelectList'},
                {dataId: 'dealNotDoneSelections', isStatic: true, workspace: 'Valuation', task: 'Valuation.DealNotDoneSelection'},
			]);
		},
		_setupValidation: function ()
		{
			App.DataStore.listen('regValidation', 'damages', function (id, damages) {
				var rules = {
					firstName: {required: true, minlength: 3},
					familyName: {required: true, minlength: 3},
					idNumber: {required: false, minlength: 13, maxlength: 13, digits: true},
					mobile: {required: true, mobile: true},
					salesAmountOffered: {number: true},
                    customerAmountOffered: {number: true},
                    bankSettlement: {number: true},
					overAllowance: {number: true},
					standInValue: {number: true},
					projectedRetail: {number: true},
					plannedMargin: {number: true},
					vehicleYear: "required",
					vehicleCategory: "required",
					vehicleMake: {required: function () {
							return $('#vehicleMake').parent().css('display') != 'none';
						}},
					vehicleModel: {required: function () {
							return $('#vehicleModel').parent().css('display') != 'none';
						}},
					vehicleType: {required: function () {
							return $('#vehicleType').parent().css('display') != 'none';
						}},
					vehicleMakeManual: {required: function () {
							return $('#vehicleMakeManual').parent().parent().css('display') != 'none';
						}},
					vehicleModelManual: {required: function () {
							return $('#vehicleModelManual').parent().parent().css('display') != 'none';
						}},
					vehicleTypeManual: {required: function () {
							return $('#vehicleTypeManual').parent().parent().css('display') != 'none';
						}},
					vehicleFuelType: "required",
					vehicleTransmissionType: "required",
					registrationNumber: "required",
					km: {required: true, digits: true}
				};
				for (var i = 0; i < damages.length; i++)
				{
					rules['damage' + damages[i].value + 'Amount'] = {number: true};
				}
				$('#frmValuationView').validate({
					"rules": rules,
					messages: {
						firstName: {
							minlength: "This field is required."
						},
						familyName: {
							minlength: "This field is required."
						},
						idNumber: {
							minlength: "Must be 13 digits.",
							maxlength: "Must be 13 digits."
						},
						vehicleYear: "This field is required.",
						vehicleCategory: "This field is required.",
						vehicleMake: "This field is required.",
						vehicleModel: "This field is required.",
						vehicleType: "This field is required.",
						vehicleMakeManual: "This field is required.",
						vehicleModelManual: "This field is required.",
						vehicleTypeManual: "This field is required.",
						vehicleFuelType: "This field is required.",
						vehicleTransmissionType: "This field is required.",
						registrationNumber: "This field is required.",
						km: {required: "This field is required."}
					},
					invalidHandler: function (event, validator) {
						var errors = validator.numberOfInvalids();
						if (0 < _w.valuationview.validations && errors) {
							var message = errors == 1
											? 'You missed 1 field. It has been highlighted'
											: 'You missed ' + errors + ' fields. They have been highlighted';
							alert(message);
						}
						_w.valuationview.validations++;
					},
					submitHandler: function (form) {
						$('#btnUpdate').prop('disabled', true);
						var data = _w.valuationview._prepValuationUpdateData();

						App.API.execTask(
										'updateValuation:' + _w.valuationview.itemId, data, {},
										_w.valuationview._onValuationUpdated, _w.taskExecError
										);
					}
				});
				try {
					_w.valuationview.validations = 0;
					$('#frmValuationView').valid();
				} catch (err) {
				}
				$('label.error').remove();
				$('.valid').removeClass('valid');
			});
		},
		_onTuReady: function (response, callback)
		{
			// Do a check here to see if we have cat other if so return else do
			if (_w.valuationview.itemData.stock.category != 8)
			{
				//
				App.API.execTask(
								'TransUnionFromMmCode', {
									Filter: {
										vehicleYear: parseInt($('#vehicleYear').val()),
										type: parseInt($('#vehicleType').val())
									}
								}, {}, function (data) {
					_w.valuationview._onTuReceived(data);
					if (callback)
					{
						callback();
					}
				}
				, function () {
					alert('There were no trade and retail from TransUnion');
					if (callback)
					{
						callback();
					}
				}
				);

			}
			else {
				if (callback)
				{
					callback();
				}
				return;
			}

		},
		_onTuReceived: function (response)
		{
			$('#btnFetchTu').prop('disabled', false);
			if ('Success' != response.Data.Status)
			{
				alert(response.Data.Status);

				if ('No Results From TransUnion' == response.Data.Status || 'No Values From TransUnion' == response.Data.Status) {
					//write zero values for transunion failed
					var vals = 0.00;
					$('#retailPrice').val(vals);
					$('#tradePrice').val(vals);
					$('#listPrice').val(vals);
					_w.valuationview.ti.hydrateParam('infRetailPrice', 'R ' + vals);
					_w.valuationview.ti.hydrateParam('infTradePrice', 'R ' + vals);
					_w.valuationview.ti.hydrateParam('infListPrice', 'R ' + vals);
				}
				return;
			}
			var vals = response.Data.VehicleDetails[0].Value;
			$('#retailPrice').val(vals.RetailPrice);
			$('#tradePrice').val(vals.TradePrice);
            $('#listPrice').val(vals.NewPrice);
			$('#MmCode').val(vals.MmCode);
			_w.valuationview.ti.hydrateParam('infRetailPrice', 'R ' + vals.RetailPrice);
			_w.valuationview.ti.hydrateParam('infTradePrice', 'R ' + vals.TradePrice);
            _w.valuationview.ti.hydrateParam('infListPrice', 'R ' + vals.NewPrice);
			_w.valuationview.ti.hydrateParam('infMmCode', ' ' + vals.MmCode);


		},
		_updatePrice: function (callback, apicall)
		{

			if ('' != $('#vehicleType').val() && null != $('#vehicleType').val())
			{
				App.API.getTask(
								'GetMmCode' + $('#vehicleType').val(), 'Stock', 'Type.GetMmCode', null,
								{id: $('#vehicleType').val()},
				function (response) {

					$('#mmCode').html(response.Data.mmCode);
					if (apicall !== false)
					{
						if ($('#vehicleYear').val()
										&& $('#vehicleType').val())
						{
							App.API.getTask(
											'TransUnionFromMmCode', 'Stock', 'Utility.TransUnionFromMmCode', null,
											{}, function (response) {
								_w.valuationview._onTuReady(response, callback);
							}, _w.taskContractError);

						}
					}
					else
					{
						if (callback)
						{
							callback();
						}
					}
				}, _w.taskContractError);
			}
			else
			{
				$('#mmCode').html('');
				if (callback)
				{
					callback();
				}
			}
		},
		_prepValuationUpdateData: function ()
		{
			function isValidEmailAddress(emailAddress) {
				var pattern = new RegExp(/^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i);
				return pattern.test(emailAddress);
			}
			;

			var data = _w.valuationview.ti.harvest();
			data.km = '' == data.km
							? 0
							: parseInt(data.km);
			var retailPrice = $('#retailPrice').val();
			var tradePrice = $('#tradePrice').val();
            var listPrice = $('#listPrice').val();
			var mmCode = $('#MmCode').val();

			data.retailPrice = ('' == retailPrice)
							? 0.00
							: parseFloat(retailPrice);
			data.tradePrice = ('' == tradePrice)
							? 0.00
							: parseFloat(tradePrice);
            data.listPrice = ('' == listPrice)
                ? 0.00
                : parseFloat(listPrice);
			delete data.damageTotal;

			if (-1 == data.make)
			{
				delete data.make;
				delete data.model;
				delete data.type;
			}
			if (-1 == data.model)
			{
				delete data.model;
				delete data.type;
			}
			if (-1 == data.type)
			{
				delete data.type;
			}

			delete data.amountOffered;
//			if ('' == data.overAllowance)
//			{
//				delete data.overAllowance;
//			}

			if ('' == data.overAllowance)
			{
				delete data.overAllowance;
			}
			else
			{
				data.overAllowance = parseFloat(data.overAllowance);
			}

			if ('' == data.standInValue)
			{
				delete data.standInValue;
			}
			else
			{
				data.standInValue = parseFloat(data.standInValue);
			}

			if ('' == data.projectedRetail)
			{
				delete data.projectedRetail;
			}
			else
			{
				data.projectedRetail = parseFloat(data.projectedRetail);
			}

			if ('' == data.plannedMargin)
			{
				delete data.plannedMargin;
			}
			else
			{
				data.plannedMargin = parseFloat(data.plannedMargin);
			}

            if ('' == data.bankSettlement)
            {
                data.bankSettlement = 0.0;
            }
            else
            {
                data.bankSettlement = parseFloat(data.bankSettlement);
            }

			if ('' == data.requiredPrice)
			{
				data.requiredPrice = 0.0;
			}
			else
			{
				data.requiredPrice = parseFloat(data.requiredPrice);
			}

			if ('' == data.mainImage)
			{
				delete data.mainImage;
			}
			if ('' == data.leftImage)
			{
				delete data.leftImage;
			}
			if ('' == data.backImage)
			{
				delete data.backImage;
			}
			if ('' == data.engineImage)
			{
				delete data.engineImage;
			}
			if ('' == data.frontImage)
			{
				delete data.frontImage;
			}
			if ('' == data.rightImage)
			{
				delete data.rightImage;
			}
			if ('' == data.interiorImage)
			{
				delete data.interiorImage;
			}
			if ('' == data.natisImage)
			{
				delete data.natisImage;
			}
			delete data.clubs;


			var postData = {Stock: {}, Valuation: {}};
			var valuationFields = [
				"firstName", "familyName", "idNumber", "mobile",
				"email", "department", "amountOffered", "bankSettlement", "overAllowance",
				"standInValue", "projectedRetail", "plannedMargin",
				"salesProfile", "amountOffered", "salesComments", "customerComments",
				"region", "city", "street", "requiredPrice", "sighted", "licenseDiscExpired",
                "dealNotDoneSelection", "dealNotDoneReason"
			];
			for (var field in data)
			{
				if (-1 == valuationFields.indexOf(field))
				{
					postData.Stock[field] = data[field];
				}
				else
				{
					postData.Valuation[field] = data[field];
				}
			}
			if ('' == postData.Valuation.idNumber)
			{
				delete postData.Valuation.idNumber;
			}


			if (!isValidEmailAddress(postData.Valuation.email))
			{
				testEmail = postData.Valuation.email;
				postData.Valuation.email = null;
			}


			if ('' == postData.Valuation.email)
			{
				postData.Valuation.email = null; //postData.Valuation.email;
			}

			var stockNum = $('#stockNumberDD').val();
			if ('' == postData.Stock.stockNumber
				&& '' != postData.Stock.stockNumberDD)
			{
				postData.Stock.stockNumber = postData.Stock.stockNumberDD;
			}
			if (undefined != postData.Stock.stockNumberDD)
			{
				delete postData.Stock.stockNumberDD;
			}

			return postData;


		},
		_onHpiDownloadButtonClick: function (event)
		{
            var hpiType = event.currentTarget.dataset.value;
            var hpiId = event.currentTarget.dataset.id;

            if('ACC' == hpiType)
            {
                App.API.getTask(
                    'printTuhpi:' + _w.stock.Id, 'Stock', 'Tuhpi.PrintAccident', _w.stock.Id,
                    {'PdfTemplate':{'recordId':hpiId}}, function () {
                        App.API.execTask(
                            'printTuhpi:' + _w.stock.Id, {}, {},
                            function () {
                            }, _w.taskExecError,
                            'EXPORT', true
                        );
                    }, _w.taskContractError
                );
            }
            else
            {
                App.API.getTask(
                    'printTuhpi:' + _w.stock.Id, 'Stock', 'Tuhpi.Print', _w.stock.Id,
                    {'PdfTemplate':{'recordId':hpiId}}, function () {
                        App.API.execTask(
                            'printTuhpi:' + _w.stock.Id, {}, {},
                            function () {
                            }, _w.taskExecError,
                            'EXPORT', true
                        );
                    }, _w.taskContractError
                );
            }

		},
        _loadHpiReportData: function (hpiData)
        {
            var tuHpiData = hpiData;

            if(0 < tuHpiData.length)
            {
                $('#HPIreportData').html('');
                var tuHpiId = '';
                var tuHpiCreated = '';
                var tuHpiType = '';
                var tuHpiButtonType = '';
            }

            for (var i = 0; i < tuHpiData.length; i++)
            {
                if(3 > i)
                {

                    tuHpiId = tuHpiData[i].id;
                    tuHpiCreated = tuHpiData[i].created;
                    tuHpiType = tuHpiData[i].hpi_type;
                    tuHpiButtonType = tuHpiData[i].hpi_type;

                    var hpiDataHtml = '<div class="control-group mobile-control-group row-fluid" style="display: block;border:1px solid #d3d3d3;" id="' + i + '">'
                        +'<div class="control-group mobile-control-group span4" style="padding-left:10px; padding-top:13px;">Last date requested:</div>'
                        +'<div class="control-group mobile-control-group span4" style="padding-left:10px;border-left:1px solid #d3d3d3; padding-top:13px;">'
                        +'<div id="tuhpiDate_' + i + '" class="span9">Not requested yet.</div>'
                        +'</div>'
                        +'<div class="control-group mobile-control-group span4" style="padding-left:10px;border-left:1px solid #d3d3d3; padding-top:13px;">'
                        +'<div id="tuhpiType_' + i + '" class="span8">Not requested yet.</div>'
                        +'<div class="span4">'
                        +'<button id="downloadTuhpi_' + tuHpiId + '" class="btn pull-right span12" data-id="' + tuHpiId + '" data-value="' + tuHpiButtonType + '" type="button" style="margin:-5px 0 0 0;" >view</button>'
                        +'</div>'
                        +'</div>'
                        +'</div>';

                    $('#HPIreportData').append(hpiDataHtml);

                    if (tuHpiId)
                    {
                        $('#tuhpiDate_' + i).html(tuHpiCreated);
                        $('#tuhpiType_' + i).html(tuHpiType);
                        $('#downloadTuhpi').show();
                        $('#HPIbtnConfirm').prop('disabled', false);
                    }
                    else
                    {
                        $('#tuhpiDate_' + i).html('Not Requested Yet');
                        $('#tuhpiType_' + i).html('Not Requested Yet');
                        $('#downloadTuhpi').hide();
                    }


                    $('#downloadTuhpi_' + tuHpiId).click(function(event)
                    {
                        _w.valuationview._onHpiDownloadButtonClick(event);
                    });

                }

            }

        },
        _onValuationUpdated : function( response )
        {
            window.location.hash = '/valuations';
        }
	};

})();